﻿ARKINV_L = AceLibrary( "AceLocale-2.2" ):new( "ARKINV" )

ARKINV = AceLibrary( "AceAddon-2.0" ):new( "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1" )

local dd = AceLibrary( "Dewdrop-2.0" )


ARKINV_G = {

	PROGRAM_NAME = "ArkInventory",
	PROGRAM_VERSION = 2.06,
	PROGRAM_BETA = nil, -- "2007-JUN-28-21-45",
	DEBUG = false,
	
	COROUTINE = {
		["RESTACK"] = nil,
	},

	PT = AceLibrary( "PeriodicTable-3.0" ),
	
	ITEM = { },
	
	ME = UnitName( "player" ) .. " - " .. GetRealmName(),
	
	PLAYER_SKILLS = { }, -- populated with a list of the current players skills whenever they change
	
	MODE = {
		["EDIT"] = false,
		["BANK"] = false,
		["COMBAT"] = false,
		["UPDATE"] = {
			["BAG"] = false,
			["BANK"] = false,
		},
	},
	
	LOCATION_BAG = 1, -- hardcoded, do not change
	LOCATION_BANK = 2, -- hardcoded, do not change
	LOCATION_KEY = 3, -- hardcoded, do not change
	LOCATION = { },
	
	WINDOW_OFFSET = 9, -- hardcoded padding size for gap inside container
	WINDOW_MIN_ROW = 1,
	WINDOW_MIN_COL = 6,

	WINDOW_MIN_WIDTH = 200,
	WINDOW_MIN_HEIGHT = 40,

	FADE_ALPHA = 0.6,
	BAG_SLOT_SIZE,
	
	-- slot type numbers, do not change this order, just add new ones to the end of the list
	SLOT_UNKNOWN = 0,
	SLOT_BAG = 1,
	SLOT_KEY = 3,
	SLOT_SOULSHARD = 5,
	SLOT_HERB = 6,
	SLOT_ENCHANTING = 7,
	SLOT_ENGINEERING = 8,
	SLOT_GEM = 9,
	SLOT_MINING = 10,
	SLOT_PROJECTILE_BULLET = 11,
	SLOT_PROJECTILE_ARROW = 12,

	GUI_NAME = "ARKINV_Frame",

	BAR_DEFAULT_COLOUR = { r = 0.0, g = 0.0, b = 0.4, a = 0.4 },
	
	SLOT_SORT_NAME = 1,
	SLOT_SORT_BAGSLOT = 2,

	ANCHOR = {
		["BOTTOMRIGHT"] = 1,
		["BOTTOMLEFT"] = 2,
		["TOPLEFT"] = 3,
		["TOPRIGHT"] = 4,
	},
	
	DIRECTION = {
		["HORIZONTAL"] = 1,
		["VERTICAL"] = 2,
	},
	
	ITEM_CHANGE = {
		["NONE"] = 0,
		["NEW"] = 1,
		["INCREASE"] = 2,
		["DECREASE"] = 3,
	},
	
	CATEGORY = { }, -- see CategoryGenerate() for how this gets populated
	
	CATEGORY_ID_DEFAULT = -401,
	
	CATEGORY_SYSTEM = { -- do NOT change the indicies - if you have to then see the ConvertOldOptions() function to remap it
		[-401] = ARKINV_L["CATEGORY_DEFAULT"],
		[-402] = ARKINV_L["CATEGORY_TRASH"],
		[-403] = ARKINV_L["CATEGORY_SOULBOUND"],
		[-404] = ARKINV_L["CATEGORY_CONSUMABLE"],
		[-405] = ARKINV_L["CATEGORY_CONTAINER"],
		[-406] = ARKINV_L["CATEGORY_KEY"],
		[-407] = ARKINV_L["CATEGORY_MISCELLANEOUS"],
		[-408] = ARKINV_L["CATEGORY_REAGENT"],
		[-409] = ARKINV_L["CATEGORY_RECIPE"],
		[-410] = ARKINV_L["CATEGORY_PROJECTILE"],
		[-411] = ARKINV_L["CATEGORY_QUEST"],
		[-412] = ARKINV_L["CATEGORY_TRADE_GOODS"],
		[-413] = ARKINV_L["CATEGORY_SOULSHARD"],
		[-414] = ARKINV_L["CATEGORY_EQUIPMENT"],
		[-415] = ARKINV_L["CATEGORY_MOUNT"],
		[-416] = ARKINV_L["CATEGORY_EQUIPMENT_SOULBOUND"],
		[-417] = ARKINV_L["CATEGORY_FOOD"],
		[-418] = ARKINV_L["CATEGORY_DRINK"],
		[-419] = ARKINV_L["CATEGORY_POTION_MANA"],
		[-420] = ARKINV_L["CATEGORY_POTION_HEAL"],
		[-421] = ARKINV_L["CATEGORY_PROJECTILE_BULLET"],
		[-422] = ARKINV_L["CATEGORY_PROJECTILE_ARROW"],
		[-423] = ARKINV_L["CATEGORY_PET_NONCOMBAT"],
		[-424] = ARKINV_L["CATEGORY_POTION"],
		[-428] = ARKINV_L["CATEGORY_REPUTATION"],
	},

	CATEGORY_SKILL = { -- do NOT change the indicies
		[-101] = ARKINV_L["CATEGORY_SKILL_ALCHEMY"],
		[-102] = ARKINV_L["CATEGORY_SKILL_BLACKSMITHING"],
		[-103] = ARKINV_L["CATEGORY_SKILL_COOKING"],
		[-104] = ARKINV_L["CATEGORY_SKILL_ENGINEERING"],
		[-105] = ARKINV_L["CATEGORY_SKILL_ENCHANTING"],
		[-106] = ARKINV_L["CATEGORY_SKILL_FIRST_AID"],
		[-107] = ARKINV_L["CATEGORY_SKILL_FISHING"],
		[-108] = ARKINV_L["CATEGORY_SKILL_HERBALISM"],
		[-109] = ARKINV_L["CATEGORY_SKILL_JEWELCRAFTING"],
		[-110] = ARKINV_L["CATEGORY_SKILL_LEATHERWORKING"],
		[-111] = ARKINV_L["CATEGORY_SKILL_MINING"],
		[-112] = ARKINV_L["CATEGORY_SKILL_SKINNING"],
		[-113] = ARKINV_L["CATEGORY_SKILL_TAILORING"],
	},
	
	CATEGORY_CLASS = { -- do NOT change the indicies
		[-201] = ARKINV_L["CATEGORY_CLASS_DRUID"],
		[-202] = ARKINV_L["CATEGORY_CLASS_HUNTER"],
		[-203] = ARKINV_L["CATEGORY_CLASS_MAGE"],
		[-204] = ARKINV_L["CATEGORY_CLASS_PALADIN"],
		[-205] = ARKINV_L["CATEGORY_CLASS_PRIEST"],
		[-206] = ARKINV_L["CATEGORY_CLASS_ROGUE"],
		[-207] = ARKINV_L["CATEGORY_CLASS_SHAMAN"],
		[-208] = ARKINV_L["CATEGORY_CLASS_WARLOCK"],
		[-209] = ARKINV_L["CATEGORY_CLASS_WARRIOR"],
	},

	CATEGORY_EMPTY = { -- do NOT change the indicies
		[-312] = ARKINV_L["CATEGORY_EMPTY_UNKNOWN"],
		[-301] = ARKINV_L["CATEGORY_EMPTY"],
		[-302] = ARKINV_L["CATEGORY_EMPTY_BAG"],
		[-303] = ARKINV_L["CATEGORY_EMPTY_KEY"],
		[-304] = ARKINV_L["CATEGORY_EMPTY_SOULSHARD"],
		[-305] = ARKINV_L["CATEGORY_EMPTY_HERB"],
		[-306] = ARKINV_L["CATEGORY_EMPTY_ENCHANTING"],
		[-307] = ARKINV_L["CATEGORY_EMPTY_ENGINEERING"],
		[-308] = ARKINV_L["CATEGORY_EMPTY_GEM"],
		[-309] = ARKINV_L["CATEGORY_EMPTY_MINING"],
		[-310] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"],
		[-311] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"],
	},

	CATEGORY_OTHER = { -- do NOT change the indicies - if you have to then see the ConvertOldOptions() function to remap it
		[-901] = ARKINV_L["CATEGORY_CORE_MATS"],
		[-902] = ARKINV_L["CATEGORY_FOOD_PET"],
		[-425] = ARKINV_L["CATEGORY_TRADE_GOODS_DEVICES"],
		[-426] = ARKINV_L["CATEGORY_TRADE_GOODS_EXPLOSIVES"],
		[-427] = ARKINV_L["CATEGORY_TRADE_GOODS_PARTS"],
	},
	
	CACHE_CATEGORY_DEFAULT = { },
	CACHE_CATEGORY_CURRENT = { },
	
}

ARKINV_G.LOCATION = {

	[ARKINV_G.LOCATION_BAG] = {
		["NAME"] = ARKINV_L["LOCATION_BAG"],
		["TEXTURE"] = "Interface\\Buttons\\Button-Backpack-Up",
		["IDS"] = { 0 },
		["player"] = ARKINV_G.ME,

		["bar_max"] = 0,
		["slot_max"] = { },
		
		["offline"] = false,
		["rescan"] = { },
		["rebuild"] = true,
		["refresh"] = true,
		["redraw"] = false,
	},

	[ARKINV_G.LOCATION_BANK] = {
		["NAME"] = ARKINV_L["LOCATION_BANK"],
		["TEXTURE"] = "Interface\\Icons\\INV_Box_03",
		["IDS"] = { BANK_CONTAINER },
		["player"] = ARKINV_G.ME,

		["bar_max"] = 0,
		["slot_max"] = { },

		["offline"] = false,
		["rescan"] = { },
		["rebuild"] = true,
		["refresh"] = true,
		["redraw"] = false,
	},

	[ARKINV_G.LOCATION_KEY] = {
		["NAME"] = ARKINV_L["LOCATION_KEY"],
		["TEXTURE"] = "Interface\\Icons\\INV_Misc_Key_04",
		["IDS"] = { KEYRING_CONTAINER },
		["player"] = ARKINV_G.ME,

		["bar_max"] = 0,
		["slot_max"] = { },

		["offline"] = false,
		["rescan"] = { },
		["rebuild"] = true,
		["refresh"] = true,
		["redraw"] = false,
	},
}


local ARKINV_SLOT_TABLE_DEFAULT_COLOUR = { r = 0.3, g = 0.3, b = 0.3 }

local ARKINV_SLOT_TABLE = {
	[ARKINV_G.SLOT_UNKNOWN] = {
		["name"] = ARKINV_L["STATUS_NAME_UNKNOWN"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_UNKNOWN"],
		["colour"] = { r = 1.0, g = 0.0, b = 0.0 }, -- red
	},
	[ARKINV_G.SLOT_BAG] = {
		["name"] = ARKINV_L["STATUS_NAME_BAG"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_BAG"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_CONTAINER_BAG"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
	},
	[ARKINV_G.SLOT_KEY] = {
		["name"] = ARKINV_L["STATUS_NAME_KEY"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_KEY"],
		["colour"] = { r = 1.0, g = 1.0, b = 0.0 }, -- yellow,
	},
	[ARKINV_G.SLOT_SOULSHARD] = {
		["name"] = ARKINV_L["STATUS_NAME_SOULSHARD"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_SOULSHARD"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_CONTAINER_SOULSHARD"],
		["colour"] = { r = 1.0, g = 0.0, b = 1.0 }, -- magenta
		["pt"] = "Container.ItemsInType.Soul Shard",
	},
	[ARKINV_G.SLOT_HERB] = {
		["name"] = ARKINV_L["STATUS_NAME_HERB"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_HERB"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_CONTAINER_HERB"],
		["colour"] = { r = 0.0, g = 1.0, b = 0.0 }, -- green
		["pt"] = "Container.ItemsInType.Herb",
	},
	[ARKINV_G.SLOT_ENCHANTING] = {
		["name"] = ARKINV_L["STATUS_NAME_ENCHANTING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_ENCHANTING"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_CONTAINER_ENCHANTING"],
		["colour"] = { r = 0.0, g = 0.0, b = 1.0 }, -- blue
		["pt"] = "Container.ItemsInType.Enchanting",
	},
	[ARKINV_G.SLOT_ENGINEERING] = {
		["name"] = ARKINV_L["STATUS_NAME_ENGINEERING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_ENGINEERING"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_CONTAINER_ENGINEERING"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
		["pt"] = "Container.ItemsInType.Engineering",
	},
	[ARKINV_G.SLOT_GEM] = {
		["name"] = ARKINV_L["STATUS_NAME_GEM"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_GEM"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_CONTAINER_GEM"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
		["pt"] = "Container.ItemsInType.Gem",
	},
	[ARKINV_G.SLOT_MINING] = {
		["name"] = ARKINV_L["STATUS_NAME_MINING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_MINING"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_CONTAINER_MINING"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
		["pt"] = "Container.ItemsInType.Mining",
	},
	[ARKINV_G.SLOT_PROJECTILE_BULLET] = {
		["name"] = ARKINV_L["STATUS_NAME_PROJECTILE_BULLET"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_QUIVER_BULLET"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
		["pt"] = "Reagent.Ammo.Bullet",
	},
	[ARKINV_G.SLOT_PROJECTILE_ARROW] = {
		["name"] = ARKINV_L["STATUS_NAME_PROJECTILE_ARROW"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"],
		["type"] = ARKINV_L["WOW_ITEM_TYPE_QUIVER_ARROW"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
		["pt"] = "Reagent.Ammo.Arrow",
	}
}


-- Binding Variables
BINDING_HEADER_ARKINV = ARKINV_G.PROGRAM_NAME
BINDING_NAME_ARKINV_TOGGLE_BAG = ARKINV_L["LOCATION_BAG"]
BINDING_NAME_ARKINV_TOGGLE_KEY = ARKINV_L["LOCATION_KEY"]
BINDING_NAME_ARKINV_TOGGLE_BANK = ARKINV_L["LOCATION_BANK"]
BINDING_NAME_ARKINV_TOGGLE_EDIT = ARKINV_L["MOD_MENU_MAIN_EDITMODE"]
BINDING_NAME_ARKINV_RESTACK_BAG = ARKINV_L["MOD_MENU_MAIN_COMPRESS"]


ARKINV:RegisterDB( "ARKINVDB" )

ARKINV:RegisterDefaults( "profile", {
	["option"] = {
		["version"] = 0,
		["rule"] = {
			["*"] = {
				["enabled"] = false,
			},
		},
		["useglobal"] = true, -- true means use the bag settings for all locations, otherwise use each locations settings
		["local"] = {
			["*"] = {
				["window"] = {
					["scale"] = 1,
					["width"] = 16,
					["border"] = true,
					["colour"] = {
						["background"] = {
							["r"] = 0,
							["g"] = 0,
							["b"] = 0,
							["a"] = 0.75,
						},
						["border"] = {
							["r"] = 1,
							["g"] = 1,
							["b"] = 1,
						},
						["baghighlight"] = {
							["r"] = 0,
							["g"] = 1,
							["b"] = 0,
						},
					},
					["pad"] = 8,
					["anchor"] = 3,   
				},
				["bar"] = {
					["per"] = 5,
					["pad"] = {
						["internal"] = 8,
						["external"] = 8,
					},
					["border"] = true,
					["colour"] = {
						["background"] = ARKINV_G.BAR_DEFAULT_COLOUR,
						["border"] = ARKINV_G.BAR_DEFAULT_COLOUR,
					},
					["showempty"] = false,
					["anchor"] = ARKINV_G.ANCHOR.BOTTOMRIGHT,
					["direction"] = ARKINV_G.DIRECTION.HORIZONTAL,
					["compact"] = false,
					["hide"] = false,
				},
				["slot"] = {
					["empty"] = {
						["alpha"] = 0.1,
						["icon"] = true,
						["border"] = true,
						["clump"] = false,
					},
					["data"] = ARKINV_SLOT_TABLE,
					["pad"] = 4,
					["border"] = true,
					["ignorehidden"] = false,
				},
				["sort"] = {
					["type"] = ARKINV_G.SLOT_SORT_BAGSLOT,
					["quality"] = true,
					["category"] = false,
					["location"] = true,
					["instant"] = false,
					["reversed"] = false,
				},
				["rule"] = { -- which bar a rule lives on, rule = bar
					[ARKINV_G.CATEGORY_ID_DEFAULT] = 1,
				},
			},
		},
	},

} )

ARKINV:RegisterDefaults( "account", {
	["option"] = {
		["version"] = 0,
		["offline"] = {
			["bank"] = true, -- keep bank data when leaving the bank
			["alt"] = true, -- keep bag & keyring on logout
			["fade"] = true,
		},
		["auto"] = {
			["open"] = {
				["bank"] = true,
				["mail"] = true,
				["trade"] = true,
				["merchant"] = true,
				["auction"] = true,
			},
			["close"] = {
				["bank"] = true,
				["mail"] = true,
				["trade"] = true,
				["merchant"] = true,
				["auction"] = true,
				["combat"] = true,
			},
		},
		["framehide"] = {
			["blizzard"] = true,
			["status"] = false,
			["header"] = false,
			["changer"] = false,
		},
		["newitem"] = {
			["show"] = false,
			["colour"] = {
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
		},
		["rule"] = {
			["*"] = {
				["order"] = -1,
				["damaged"] = false,
				["name"] = "",
				["formula"] = "",
				["compiled"] = "",
			},
		},
		["nextrule"] = 1,
		["showdisabled"] = true,
	},
	["cache"] = {
		["who"] = {
			["*"] = {
				["loc"] = {
					["*"] = {
						["bag"] = { },
						["bar"] = { },
						["container"] = { },
						["slot_count"] = 0,
						["bar_count"] = 0,
					},
				},
				["name"] = "",
				["class"] = "",
				["faction"] = "UNKNOWN",
				["realm"] = "UNKNOWN",
				["skills"] = { },
			},
		},
	},
	
} )



local ARKINV_SlashCommandOptions = {
	type = "group",
	args = {

		gui = {
			type = "group",
			name = "gui",
			desc = "gui options",
			args = {
				reset = {
					type = "execute",
					name = "reset",
					desc = "centers the interface on the screen",
					func = function()
						for loc_id in pairs( ARKINV_G.LOCATION ) do
							getglobal( ARKINV_G.GUI_NAME .. loc_id ):SetPoint( "TOPLEFT", UiParent, "CENTER" )
						end
					end
				},
			},
		},
		
		db = {
			type = "group",
			name = "db",
			desc = "db options",
			args = {
				reset = {
					type = "group",
					name = "reset",
					desc = "resets all options back to the defaults",
					args = {
						confirm = {
							type = "execute",
							name = "confirm",
							desc = "confirms the database reset",
							func = function() ARKINV:DatabaseReset() end
						},
					},
				},
			},
		},
		
		cache = {
			type = "group",
			name = "cache",
			desc = "cache options",
			args = {
				erase = {
					type = "group",
					name = "erase",
					desc = "erases all cached data",
					args = {
						confirm = {
							type = "execute",
							name = "confirm",
							desc = "confirms the cache erase",
							func = function() ARKINV:CacheErase() end
						},
					},
				},
			},
		},
		
	},
}

ARKINV:RegisterChatCommand( { "/arkinv", "/ai" }, ARKINV_SlashCommandOptions )


function ARKINV:DatabaseReset()

	-- /ai db reset confirm

	self:ContainerCloseAll()

	self:ResetDB( "profile" )
	self:Print( GREEN_FONT_COLOR_CODE .. "Database has been reset." )
	self:Print( GREEN_FONT_COLOR_CODE .. "All options are back at defaults." )
	
	self:CategoryGenerate()
	
	self:BagTaintAll()
	self:ContainerGenerateRebuildAll()

end

function ARKINV:CacheErase()

	-- /ai cache erase confirm

	self:ContainerCloseAll()

	for k in pairs( self.db.account.cache.who ) do
		self.db.account.cache.who[k] = nil
	end
	
	self:Print( "All cached data has been erased." )
	
	self:CategoryGenerate()
	
	self:BagTaintAll()
	self:ContainerGenerateRebuildAll()
	
end

function ARKINV:TableConcat2( t, d )

	if type( t ) ~= "table" then return "not a table" end
	
	local n = { }
	
	for i in pairs( t ) do
		if t[i] then
			if type( t[i] ) == "boolean" then
				if t[i] == true then
					tinsert( n, i .. " = true" )
				else
					tinsert( n, i .. " = false" )
				end
			elseif type( t[i] ) == "table" then
				tinsert( n, i .. " = { " )
				tinsert( n, self:TableConcat2( t[i], ", " ) )
				tinsert( n, " }" )
			else
				tinsert( n, i .. " = " .. t[i] )
			end
		else
			tinsert( n, i .. " = nil" )
		end
	end

	if d then
		return table.concat( n, d )
	else
		return table.concat( n )
	end
	
end

function ARKINV:TableConcat( t, d )

	if type( t ) ~= "table" then return "not a table" end
	
	local n = { }
	
	local mx = 0
	for k, v in pairs( t ) do
		if k > mx then mx = k end
	end
	
	if mx == 0 then return "nil" end
	
	for i = 1, mx do
		if t[i] then
			if type( t[i] ) == "boolean" then
				if t[i] == true then
					tinsert( n, "true" )
				else
					tinsert( n, "false" )
				end
			elseif type( t[i] ) == "table" then
				tinsert( n, "{ " )
				tinsert( n, self:TableConcat2( t[i], ", " ) )
				tinsert( n, " }" )
			else
				tinsert( n, t[i] )
			end
		else
			tinsert( n, "nil" )
		end
	end

	if d then
		return table.concat( n, d )
	else
		return table.concat( n )
	end
	
end

function ARKINV:PrintPlus( msg_in, debuginfo )

	-- msg = { date( "%X" ), " " }
	msg = { string.sub( format( "%05.3f", GetTime() ), -6 ), " " }
	
	if msg_in == nil then
	
		tinsert( msg, "nil" )
	
	elseif type( msg_in ) == "table" then
	
		tinsert( msg, self:TableConcat( msg_in ) )
	
	else
	
		tinsert( msg, msg_in )
	
	end
	
	if debuginfo and debuginfo["m"] and debuginfo["t"] then
		tinsert( msg, " [" )
		tinsert( msg, gcinfo() - debuginfo.m )
		tinsert( msg, "Kb / " )
		tinsert( msg,self:DebugTimeDiff( debuginfo.t ) )
		tinsert( msg, "ms]" )
	end
	
	self:Print( table.concat( msg ) )
	
end
	
function ARKINV:Debug( msgdata, debuginfo )

	if ARKINV_G.DEBUG and DEFAULT_CHAT_FRAME then
	
		self:PrintPlus( msgdata, debuginfo )
	
	end
	
end

function ARKINV:tableSum( tbl, fcn )
	local r = 0
	for k, v in pairs( tbl ) do
		r = r + ( fcn( v ) or 0 )
	end
	return r
end

function ARKINV:tableMax( tbl, fcn )
	local r = nil
	for k, v in pairs( tbl ) do
		if not r then
			r = ( fcn( v ) or 0 )
		else
			if ( fcn( v ) or 0 ) > r then
				r = ( fcn( v ) or 0 )
			end
		end
	end
	return r
end

function ARKINV:tableElements( tbl )
	local r = 0
	for _, _ in pairs( tbl ) do
		r = r + 1
	end
	return r
end

function ARKINV:spairs( tbl, comparator )

	local sortedKeys = {}
	for k, v in pairs( tbl ) do
		tinsert( sortedKeys, k )
	end
	sort( sortedKeys, comparator )
	local i = 0
	local function _f( _s, _v )
		i = i + 1
		local k = sortedKeys[i]
		if ( k ) then
			return k, tbl[k]
		end
	end
	return _f, nil, nil

end

function ARKINV:PT_ItemInSets( item, setnames )

	if not item or not setnames then return false end

	for setname in string.gmatch( setnames, "[^,]+" ) do
		
		r = ARKINV_G.PT:ItemInSet( item, strtrim( setname ) )
		if r then
			return true
		end
		
	end

	return false
	
end

function ARKINV:MakeNullStringEmpty( arg )
	if not arg then arg = "" end
	return tostring( arg )
end

function ARKINV:NilString( arg )
	if not arg then arg = "nil" end
	return tostring( arg )
end

function ARKINV:GetItemTexture( h )
	if h then
		t = select( 10, GetItemInfo( h ) )
		return t
	end
end

function ARKINV:GetItemID( h )
	item_id, item_enchant, item_suffix = strmatch( ( h or "" ) , "item:(%-?%d+):(%-?%d+):%-?%d+:%-?%d+:%-?%d+:%-?%d+:(%-?%d+):%-?%d+" )
	return ( item_id or 0 ) .. ":" .. ( item_enchant or 0 ) .. ":" .. ( item_suffix or 0 )
end

function ARKINV:GetItemName( h )
	if h then
		t = GetItemInfo( h )
		return t
	end
end

function ARKINV:GetItemCacheID( i )

	soulbound = 0
	if i.sb then soulbound = 1 end
	
	return self:GetItemID( i.h ) .. ":" .. soulbound
	
end

function ARKINV:Round( n, dp )
	local m = 10 ^ ( dp or 0 )
	return math.floor( n * m + 0.5 ) / m
end

function ARKINV:DebugTimeDiff( t )

	if not t or type( t ) ~= "number" then return -1 end
	
	return math.floor( ( GetTime() - t ) * 1000 + 0.5 )

end


function ARKINV:OnInitialize()
	-- Called when the addon is loaded

	self:CategoryGenerate()
	self:ConvertOldOptions()
	
	for x = 1, NUM_BAG_SLOTS do
		tinsert( ARKINV_G.LOCATION[ARKINV_G.LOCATION_BAG].IDS, x )
	end

	for x = NUM_BAG_SLOTS + 1, NUM_BAG_SLOTS + NUM_BANKBAGSLOTS do
		tinsert( ARKINV_G.LOCATION[ARKINV_G.LOCATION_BANK].IDS, x )
	end
	
	ARKINV_G.StealthTooltip = ARKCORE_Class_StealthTooltip:new( "ARKINV_StealthTooltip" )

end

function ARKINV:OnEnable()
	-- Called when the addon is enabled


	self:CategoryGenerate()

	self:RegisterBucketEvent( "EVENT_ARKINV_BAG_UPDATE_BUCKET", 0.08 )
	
	self:RegisterEvent( "BAG_UPDATE", "EVENT_ARKINV_BAG_UPDATE" )
	self:RegisterEvent( "PLAYERBANKSLOTS_CHANGED", "EVENT_WOW_PLAYERBANKSLOTS_CHANGED" ) -- one of the slots in bag -1 (main bank) have changed

	self:RegisterEvent( "ITEM_LOCK_CHANGED", "EVENT_WOW_ITEM_LOCK_CHANGED" )
	self:RegisterEvent( "BAG_UPDATE_COOLDOWN", "EVENT_WOW_BAG_UPDATE_COOLDOWN" )

	self:RegisterEvent( "PLAYERBANKBAGSLOTS_CHANGED", "EVENT_WOW_PLAYERBANKBAGSLOTS_CHANGED" ) -- triggered when you purchase a new bank bag slot
	
	self:RegisterEvent( "PLAYER_REGEN_DISABLED", "EVENT_WOW_PLAYER_REGEN_DISABLED" ) -- player about to enter combat
	self:RegisterEvent( "PLAYER_REGEN_ENABLED", "EVENT_WOW_PLAYER_REGEN_ENABLED" ) -- player left combat

	self:RegisterEvent( "BANKFRAME_OPENED", "EVENT_WOW_BANKFRAME_OPENED" )
	self:RegisterEvent( "BANKFRAME_CLOSED", "EVENT_WOW_BANKFRAME_CLOSED" )
	
	self:RegisterEvent( "MAIL_SHOW", "EVENT_WOW_MAIL_SHOW" )
	self:RegisterEvent( "MAIL_CLOSED", "EVENT_WOW_MAIL_CLOSED" )

	self:RegisterEvent( "TRADE_SHOW", "EVENT_WOW_TRADE_SHOW" )
	self:RegisterEvent( "TRADE_CLOSED", "EVENT_WOW_TRADE_CLOSED" )

	self:RegisterEvent( "AUCTION_HOUSE_SHOW", "EVENT_WOW_AUCTION_HOUSE_SHOW" )
	self:RegisterEvent( "AUCTION_HOUSE_CLOSED", "EVENT_WOW_AUCTION_HOUSE_CLOSED" )

	self:RegisterEvent( "MERCHANT_SHOW", "EVENT_WOW_MERCHANT_SHOW" )
	self:RegisterEvent( "MERCHANT_CLOSED", "EVENT_WOW_MERCHANT_CLOSED" )
	
	self:RegisterEvent( "SKILL_LINES_CHANGED", "EVENT_WOW_SKILL_LINES_CHANGED" ) -- triggered when you gain or lose a skill
	
	
	self:RegisterEvent( "PLAYER_LOGIN", "EVENT_WOW_PLAYER_LOGIN" ) --Triggered immediately before PLAYER_ENTERING_WORLD on login and UI Reload, but NOT when entering/leaving instances.
	self:RegisterEvent( "PLAYER_LOGOUT", "EVENT_WOW_PLAYER_LOGOUT" ) --Sent when the player logs out or the UI is reloaded, after PLAYER_LEAVING_WORLD, but before variables are saved.
	

	-- tag all bags as needed to be scanned
	self:BagTaintAll()
	
	self:Print( format( "v%.2f Enabled.  Type /ARKINV or /AI for help.", ARKINV_G.PROGRAM_VERSION ) )
	
	_, self.db.account.cache.who[ARKINV_G.ME].class = UnitClass( "player" ) -- localised, internal
	_, self.db.account.cache.who[ARKINV_G.ME].faction = UnitFactionGroup( "player" )  -- internal, localised
	self.db.account.cache.who[ARKINV_G.ME].realm = GetRealmName()
	self.db.account.cache.who[ARKINV_G.ME].name = ARKINV_G.ME .. " - " .. self.db.account.cache.who[ARKINV_G.ME].faction
	
	self:HookBlizzardAPI()
	
end

function ARKINV:OnDisable()
	-- Called when the addon is disabled

	--self:UnhookAll()
	
	self:ContainerCloseAll()
	
	--self:Debug( "Disabled" )
	
end

function ARKINV:OnProfileEnable()
    -- this is called every time your profile changes (after the change)
	self:ConvertOldOptions()
end

function ARKINV:OnProfileDisable()
    -- this is called every time your profile changes (before the change)
	dd:Close()
	self:ContainerCloseAll()
end

function ARKINV:EVENT_ARKINV_BAG_UPDATE_BUCKET( tid )

	--local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	--tid is a table in the format containerid = true so we need to look through to pull out the container id's

	id = { }
	for k in pairs( tid ) do
		tinsert( id, k )
	end
	
	--self:PrintPlus( { RED_FONT_COLOR_CODE, "BAG_UPDATE( ", id, " )" } )
	
	self:BagTaint( id )
	self:ContainerGenerateAll()
	
	--self:PrintPlus( { RED_FONT_COLOR_CODE, "BAG_UPDATE() " }, debuginfo )
	
end

function ARKINV:EVENT_ARKINV_BAG_UPDATE( id )
	--self:PrintPlus( { RED_FONT_COLOR_CODE, "EVENT_ARKINV_BAG_UPDATE( ", id, " )" } )
	self:ContainerRestackResume()
	self:TriggerEvent( "EVENT_ARKINV_BAG_UPDATE_BUCKET", id )
end

function ARKINV:EVENT_WOW_BAG_UPDATE_COOLDOWN( arg1 )
	
	-- no cooldown data is saved so a scan is not required, just draw the window
	
	if not ARKINV_G.MODE.COMBAT then
	-- if we're in combat ignore cooldown updates

		if not arg1 then
			self:ContainerGenerateAll()
		else
			self:ContainerGenerate( self:BagLocation( arg1 ) )
		end
		
	end
	
end

function ARKINV:EVENT_WOW_ITEM_LOCK_CHANGED()
	
	-- no lock data is saved so a scan is not required, just draw the window

	if not ARKINV_G.MODE.COMBAT then
		-- if we're in combat ignore item locks
		self:ContainerGenerateAll()
	end

end

function ARKINV:EVENT_WOW_PLAYERBANKSLOTS_CHANGED()
	--self:PrintPlus( { RED_FONT_COLOR_CODE, "PLAYERBANKSLOTS_CHANGED" } )
	self:EVENT_ARKINV_BAG_UPDATE( -1 )
end

function ARKINV:EVENT_WOW_PLAYERBANKBAGSLOTS_CHANGED()
	-- self:PrintPlus( { RED_FONT_COLOR_CODE, "PLAYERBANKBAGSLOTS_CHANGED" } )
	-- player just purchased another bank bag slot
	self:BagChangerUpdateBagSlotStatus()
end

function ARKINV:EVENT_WOW_PLAYER_REGEN_DISABLED()
	-- entered combat
	
	--self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_REGEN_DISABLED()" } )
	
	ARKINV_G.MODE.COMBAT = true
	
	if self.db.account.option.auto.close.combat then
		self:ContainerCloseAll()
	end
	
end

function ARKINV:EVENT_WOW_PLAYER_REGEN_ENABLED()
	-- left combat
	
	--self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_REGEN_ENABLED()" } )
	
	ARKINV_G.MODE.COMBAT = false
	self:ContainerGenerateAll()
	
end

function ARKINV:EVENT_WOW_BANKFRAME_OPENED()

	--self:Debug( { RED_FONT_COLOR_CODE, "BANKFRAME_OPENED()" } )
	
	ARKINV_G.MODE.BANK = true
	
	--self:BagTaintAll()

	if self.db.account.option.framehide.blizzard then
	
		if self.db.account.option.auto.open.bank then
			self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
			self:ContainerOpen( ARKINV_G.LOCATION_BANK, ARKINV_G.ME )
		else
			-- regenerate the view in case they were looking at the bank "offline", make it "online"
			self:ContainerOpen( ARKINV_G.LOCATION_BANK, ARKINV_G.ME )
		end

		self:ContainerGenerateRefresh( ARKINV_G.LOCATION_BANK )
	
	end
	
end

function ARKINV:EVENT_WOW_BANKFRAME_CLOSED()

	--self:Debug( { RED_FONT_COLOR_CODE, "BANKFRAME_CLOSED()" } )
	
	ARKINV_G.MODE.BANK = false

	if self.db.account.option.auto.close.bank then
		-- close windows on leaving the bank
		self:ContainerCloseAll()
	else
		-- refresh the bank window so it shows offline
		self:ContainerGenerateRefresh( ARKINV_G.LOCATION_BANK )
	end
	
end

function ARKINV:EVENT_WOW_MAIL_SHOW()
	--self:Debug( { RED_FONT_COLOR_CODE, "MAIL_SHOW" } )
	if self.db.account.option.auto.open.mail and self.db.account.option.framehide.blizzard then
		self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
	end
end

function ARKINV:EVENT_WOW_MAIL_CLOSED()
	--self:Debug( { RED_FONT_COLOR_CODE, "MAIL_CLOSED" } )
	if self.db.account.option.auto.close.mail then
		self:ContainerClose( ARKINV_G.LOCATION_BAG )
	end
end

function ARKINV:EVENT_WOW_TRADE_SHOW()
	--self:Debug( { RED_FONT_COLOR_CODE, "TRADE_SHOW" } )
	if self.db.account.option.auto.open.trade and self.db.account.option.framehide.blizzard then
		self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
	end
end

function ARKINV:EVENT_WOW_TRADE_CLOSED()
	--self:Debug( { RED_FONT_COLOR_CODE, "TRADE_CLOSED" } )
	if self.db.account.option.auto.close.trade then
		self:ContainerClose( ARKINV_G.LOCATION_BAG )
	end
end

function ARKINV:EVENT_WOW_AUCTION_HOUSE_SHOW()
	--self:Debug( { RED_FONT_COLOR_CODE, "AUCTION_HOUSE_SHOW" } )
	if self.db.account.option.auto.open.auction and self.db.account.option.framehide.blizzard then
		self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
	end
end

function ARKINV:EVENT_WOW_AUCTION_HOUSE_CLOSED()
	--self:Debug( { RED_FONT_COLOR_CODE, "AUCTION_HOUSE_CLOSED" } )
	if self.db.account.option.auto.close.auction then
		self:ContainerClose( ARKINV_G.LOCATION_BAG )
	end
end

function ARKINV:EVENT_WOW_MERCHANT_SHOW()
	--self:Debug( { RED_FONT_COLOR_CODE, "MERCHANT_SHOW" } )
	if self.db.account.option.auto.open.merchant and self.db.account.option.framehide.blizzard then
		self:ContainerOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME )
	end
end

function ARKINV:EVENT_WOW_MERCHANT_CLOSED()
	--self:Debug( { RED_FONT_COLOR_CODE, "MERCHANT_CLOSED" } )
	if self.db.account.option.auto.close.merchant then
		self:ContainerClose( ARKINV_G.LOCATION_BAG )
	end
end


function ARKINV:EVENT_WOW_SKILL_LINES_CHANGED()
	--self:Debug( { RED_FONT_COLOR_CODE, "SKILL_LINES_CHANGED" } )
	
	ARKINV_G.CACHE_CATEGORY_DEFAULT = { }
	self:SkillGet()
	self:BagTaintAll()
	
end


function ARKINV:EVENT_WOW_PLAYER_LOGIN()
	--self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_LOGIN" } )
	self:CacheCleanup()
end

function ARKINV:EVENT_WOW_PLAYER_LOGOUT()
	--self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_LOGOUT" } )
	-- scan everything on logout
	--self:BagTaintAll()
	--self:BagScanAll()
	self:CacheCleanup()
end

function ARKINV:EVENT_WOW_PLAYER_QUIT()
	--self:Debug( { RED_FONT_COLOR_CODE, "PLAYER_LOGOUT" } )
	self:CacheCleanup()
end



function ARKINV:ContainerOpen( loc_id, player )

	local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }
	
	if not loc_id then return end
	
	--self:Debug( { GREEN_FONT_COLOR_CODE, "ContainerOpen( ", loc_id, " ) start" } )

	if not player then
		player = ARKINV_G.ME
	end

	getglobal( ARKINV_G.GUI_NAME .. loc_id ):Show()

	ARKINV_G.LOCATION[loc_id].redraw = true
		
	if ARKINV_G.LOCATION[loc_id].player ~= player then
		ARKINV_G.LOCATION[loc_id].player = player
		self:ContainerGenerateRebuild( loc_id )
	else
		self:ContainerGenerateRefresh( loc_id )
	end

	--self:Debug( { GREEN_FONT_COLOR_CODE, "ContainerOpen( ", loc_id, " ) end" }, debuginfo )
	
end

function ARKINV:ContainerCloseAll()
	self:ContainerClose()
end

function ARKINV:ContainerClose( w )

	for loc_id in pairs( ARKINV_G.LOCATION ) do
		if not w or w == loc_id then
			getglobal( ARKINV_G.GUI_NAME .. loc_id ):Hide()
		end
	end
	
	if self.db.account.option.framehide.blizzard and ARKINV_G.MODE.BANK and w and w == ARKINV_G.LOCATION_BANK then
		-- close blizzards bank frame if we're hiding blizzard frames, we're at the bank, and the bank window was closed
		CloseBankFrame()
	end
	
	if ARKINV_G.MODE.EDIT then
		-- if the edit mode is active then disable edit mode and taint so it's rebuilt when next opened
		ARKINV_G.MODE.EDIT = false
		self:ContainerGenerateRebuildAll()
	end
	
end

function ARKINV:ContainerToggle( loc_id )

	local obj = getglobal( ARKINV_G.GUI_NAME .. loc_id )

	if obj then
		if obj:IsVisible() then
			self:ContainerClose( loc_id )
		else
			self:ContainerOpen( loc_id )
		end
	end
	
end

function ARKINV:ItemSortKeyRegenerate()

	-- rebuild sort key for all items
	for loc_id, loc in pairs( self.db.account.cache.who[ARKINV_G.ME].loc ) do
		for bagnum, bag in pairs( loc.bag ) do	
			for slotnum, slot in pairs( bag.slot ) do
				self:ItemSortKeyGenerate( loc_id, self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag[bagnum].slot[slotnum] )
			end
		end
	end

end

function ARKINV:ItemSortKeyGenerate( loc_id, i )

	-- default sort by bag then slot
	local s = { format( "%04i %04i", i.bagnum, i.slotnum ) }
	
	-- if sorting by name then there are extra sort options that need to be included
	if self:OptionLocalGet( loc_id, { "sort", "type" } ) == ARKINV_G.SLOT_SORT_NAME then
	
		local t
		
		-- include the name (reversed if selected)
		if self:OptionLocalGet( loc_id, { "sort", "reversed" } ) then
			t = self:ReverseName( self:GetItemName( i.h ) or "!" )
		else
			t = self:GetItemName( i.h ) or "!"
		end
		tinsert( s, 1, t )
		
		
		-- include the slot type
		if not i.h then
			t = self:BagType( i.bagnum )
		else
			t = 0
		end
		tinsert( s, 2, format( "%04i", t ) )
		
		
		-- include the item count
		tinsert( s, 3, format( "%04i", i.count ) )
		
		
		-- include rarity (if selected)
		if i.h and self:OptionLocalGet( loc_id, { "sort", "quality" } ) then
			t = i.q
		else
			t = 0
		end
		tinsert( s, 1, format( "%02i", t ) )
		

		-- include location (if selected) to start of sort
		local item_type = "!"
		local item_subtype = "!"
		local item_equiploc = "!"
		
		if i.h and self:OptionLocalGet( loc_id, { "sort", "location" } ) then
		
			item_type, item_subtype, _, item_equiploc = select( 6, GetItemInfo( i.h ) )
				
			if not item_type or item_type == "" then
				item_type = "!"
			end
			
			if not item_subtype or item_subtype == "" then
				item_subtype = "!"
			end
			
			if not item_equiploc or item_equiploc == "" then
				item_type = "!"
				item_subtype = "!"
				item_equiploc = "!"
			else
				item_equiploc = getglobal( item_equiploc )
			end

		end
		tinsert( s, 1, string.format( "%s %s %s", item_equiploc, item_type, item_subtype ) )

		
		-- include category (if selected) to start of sort
		local c_type = 0
		local c_index = 0
		local c_order = 0
		
		if i.h and self:OptionLocalGet( loc_id, { "sort", "category" } ) then
			
			if i.cat > 0 then
				c_type = 1
				c_index = i.cat
				c_order = self.db.account.option.rule[i.cat].order
			else
				c_index = abs( i.cat )
			end
			
		end
		tinsert( s, 1, format( "%02i %06i %06i", c_type, c_order, c_index ) )
		
	end

	i["sort"] = table.concat( s, " " )

end

function ARKINV:NewItemReset( loc_id )

	-- reset new item text
	for bagnum, bag in pairs( self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag ) do	
		for slotnum, slot in pairs( bag.slot ) do
			self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag[bagnum].slot[slotnum].new = ARKINV_G.ITEM_CHANGE.NONE
		end
	end

end



function ARKINV:BagLocation( id )

	if not id then
		return
	end
	
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
			if bagnum == id then
				return loc_id
			end
		end
	end

	self:Print( RED_FONT_COLOR_CODE .. "BagLocation( " .. id .. " ), value not coded" )
	return nil

end

function ARKINV:BagType( id )

	if id == -2 then
		return ARKINV_G.SLOT_KEY
	elseif id == -1 or id == 0 then
		return ARKINV_G.SLOT_BAG
	end

	local h = GetInventoryItemLink( "player", ContainerIDToInventoryID( id ) )
	
	if h then
	
		local t, s = select( 6, GetItemInfo( h ) )

		if t == ARKINV_L["WOW_ITEM_TYPE_CONTAINER"] then
		
			if s == ARKINV_L["WOW_ITEM_TYPE_CONTAINER_BAG"] then
				return ARKINV_G.SLOT_BAG
			elseif s == ARKINV_L["WOW_ITEM_TYPE_CONTAINER_SOULSHARD"] then
				return ARKINV_G.SLOT_SOULSHARD
			elseif s == ARKINV_L["WOW_ITEM_TYPE_CONTAINER_HERB"] then
				return ARKINV_G.SLOT_HERB
			elseif s == ARKINV_L["WOW_ITEM_TYPE_CONTAINER_ENCHANTING"] then
				return ARKINV_G.SLOT_ENCHANTING
			elseif s == ARKINV_L["WOW_ITEM_TYPE_CONTAINER_ENGINEERING"] then
				return ARKINV_G.SLOT_ENGINEERING
			elseif s == ARKINV_L["WOW_ITEM_TYPE_CONTAINER_GEM"] then
				return ARKINV_G.SLOT_GEM
			elseif s == ARKINV_L["WOW_ITEM_TYPE_CONTAINER_MINING"] then
				return ARKINV_G.SLOT_MINING
			end
			
		elseif t == ARKINV_L["WOW_ITEM_TYPE_QUIVER"] then
		
			if s == ARKINV_L["WOW_ITEM_TYPE_QUIVER_ARROW"] then
				return ARKINV_G.SLOT_PROJECTILE_ARROW
			elseif s == ARKINV_L["WOW_ITEM_TYPE_QUIVER_BULLET"] then
				return ARKINV_G.SLOT_PROJECTILE_BULLET
			end
			
		end
	
		--self:Print( "debug unknown bag type: bagnum=" .. id .. ", type=" .. t .. " (" .. ARKINV_L["WOW_ITEM_TYPE_CONTAINER"] .. ") , subtype=" .. s .. " (" .. ARKINV_L["WOW_ITEM_TYPE_CONTAINER_BAG"] .. ")" )
		return ARKINV_G.SLOT_UNKNOWN
	
	end

	-- empty bag slots
	return ARKINV_G.SLOT_BAG
	
end

function ARKINV:BagTaintAll()

	for _, loc_id in pairs( ARKINV_G.LOCATION ) do
		self:BagTaint( loc_id.IDS )
	end

end

function ARKINV:BagTaint( bagnum_table )

	--self:Debug( { GREEN_FONT_COLOR_CODE, "BagTaint() start" } )

	local loc_id
	
	for _, bagnum in pairs( bagnum_table ) do
	
		--self:PrintPlus( { "flagging bag ", bagnum, " for rescan" } )
	
		loc_id = self:BagLocation( bagnum )
	
		ARKINV_G.LOCATION[loc_id].rescan[bagnum] = true
		
	end

	--self:Debug( { GREEN_FONT_COLOR_CODE, "BagTaint() end" } )
	
end

function ARKINV:BagScanAll()

	--self:Debug( { GREEN_FONT_COLOR_CODE, "BagScanAll() start" } )
	
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
			self:BagScan( bagnum )
		end
	end
	
	--self:Debug( { GREEN_FONT_COLOR_CODE, "BagScanAll() end  [used", mem, "]" } )
	
end

function ARKINV:BagScan( bagnum )

	if not ( bagnum ) then
		return
	end

	-- self:PrintPlus( { GREEN_FONT_COLOR_CODE, "BagScan( ", bagnum, " ) start" } )

	local loc_id = self:BagLocation( bagnum )
	if not loc_id then
		return
	end

	
	-- check rescan tag
	if not ARKINV_G.LOCATION[loc_id].rescan[bagnum] then
		--self:Debug( { "aborted scan of bag ", bagnum, ", no recorded change" } )
		return
	end

	if loc_id == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE.BANK == false then
		--self:Debug( { "aborted scan of bag ", bagnum, ", not at bank" } )
		return
	end


	local tainted = false
	
	local bag = { }
	bag["count"] = GetContainerNumSlots( bagnum )
	bag["empty"] = 0
	bag["type"] = self:BagType( bagnum )
	bag["slot"] = { }
	
	local i, ob, oi, item_id, item_suffix, item_enchant

	--self:Debug( { "bag ", bagnum, " has ", bag.count, " slots" } )
	
	for slotnum = 1, bag.count do
	
		i = { }
		i["bagnum"] = bagnum
		i["slotnum"] = slotnum
		i["h"] = GetContainerItemLink( bagnum, slotnum )
		i["sb"] = false
		i["count"] = 0
		i["q"] = 0
		
		if i.h then
			_, i["count"] = GetContainerItemInfo( bagnum, slotnum )
			_, _, i["q"] = GetItemInfo( i.h )

			-- check for soulbound
			ARKINV_G.StealthTooltip:SetBagItem( bagnum, slotnum )
			if ARKINV_G.StealthTooltip:Contains( ARKINV_L["WOW_TOOLTIP_SOULBOUND"] ) then
				i["sb"] = true
			end

		else
			-- empty slot

			bag.empty = bag.empty + 1

		end

		i["id"] = self:GetItemID( i.h )
		
		i["cat"], i["catdef"] = self:ItemCategoryGet( i, bag.type, bagnum, slotnum )
		--self:Debug( { "bag=", bagnum, ", slot=", slotnum, ", item=", i.id, ", category=", i.cat, ", default=", i.catdef } )
		
		self:ItemSortKeyGenerate( loc_id, i )
		
		
		-- save the data
		bag.slot[slotnum] = i

		

--		if not tainted then

			ob = self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag[bagnum]

			if not ob then
			
				--  bag added
				--self:Debug( { "tainted, bag=", bagnum, ", new bag" } )
				tainted = true
				
			else
			
				oi = ob.slot[slotnum]
				
				if not oi then
					--  the old slot doesnt exist - bag increased in size?
					i["new"] = ARKINV_G.ITEM_CHANGE.NONE
					--self:Debug( { "tainted, bag=", bagnum, ", slot=", slotnum, ", new slot" } )
					tainted = true
				elseif ( i.h and not oi.h ) then
					-- item added
					i["new"] = ARKINV_G.ITEM_CHANGE.NEW
					--self:Debug( { "tainted, bag=", bagnum, ", slot=", slotnum, ", item added" } )
					tainted = true
				elseif ( not i.h and oi.h ) then
					-- item removed
					i["new"] = ARKINV_G.ITEM_CHANGE.NONE
					--self:Debug( { "tainted, bag=", bagnum, ", slot=", slotnum, ", item removed" } )
					tainted = true
				elseif ( i.h and oi.h and i.h ~= oi.h ) then
					-- different item
					if i.id ~= oi.id then
						i["new"] = ARKINV_G.ITEM_CHANGE.NEW
					end
					--self:Debug( { "tainted, bag=", bagnum, ", slot=", slotnum, ", item changed" } )
					tainted = true
				elseif ( i.sb and not oi.sb ) or ( not i.sb and oi.sb ) then
					-- soulbound changed
					i["new"] = ARKINV_G.ITEM_CHANGE.NEW
					--self:Debug( { "tainted, bag=", bagnum, ", slot=", slotnum, ", soulbound changed" } )
					tainted = true
				elseif i.count ~= oi.count then
					-- item count changed, not tainted but needs to be refreshed
					if i.count > oi.count then
						--self:PrintPlus( { "tainted, bag=", bagnum, ", slot=", slotnum, ", increased" } )
						i["new"] = ARKINV_G.ITEM_CHANGE.INCREASE
					else
						--self:PrintPlus( { "tainted, bag=", bagnum, ", slot=", slotnum, ", decreased" } )
						i["new"] = ARKINV_G.ITEM_CHANGE.DECREASE
					end
					
					ARKINV_G.LOCATION[loc_id].refresh = true
				elseif ( i.cat and not oi.cat ) or ( not i.cat and oi.cat ) or ( i.cat and oi.cat and i.cat ~= oi.cat ) then
					-- category changed
					--self:Debug( { "tainted, bag=", bagnum, ", slot=", slotnum, ", category changed" } )
					tainted = true
				end
			
			end
			
--		end
		
	end

	self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag[bagnum] = bag
	
	if tainted then
		--self:Debug( { "bag ", bagnum, " tainted, force rebuild" } )
		ARKINV_G.LOCATION[loc_id].rebuild = true
	end


	-- reset rescan tag
	ARKINV_G.LOCATION[loc_id].rescan[bagnum] = nil
	
	-- self:PrintPlus( { GREEN_FONT_COLOR_CODE, "BagScan( ", bagnum, " ) end" } )
	
end



function ARKINV:CategoryBar( loc_id, category_id )
	return self:OptionLocalGet( loc_id, { "rule", category_id } )
end

function ARKINV:CategoryLocationSet( loc_id, category_id, barnum )
	if category_id ~= ARKINV_G.CATEGORY_ID_DEFAULT or barnum then
		self:OptionLocalSet( loc_id, { "rule", category_id }, barnum )
	end
end

function ARKINV:CategoryLocationGet( loc_id, category_id )
	-- maps category id's to the bars they are assigned to
	local cat = self:CategoryBar( loc_id, category_id )
	
	if not cat then
		-- if this category hasn't been assigned to a bar then return the bar that DEFAULT is using
		return self:CategoryBar( loc_id, ARKINV_G.CATEGORY_ID_DEFAULT ), true
	else
		return cat, false
	end
end

function ARKINV:CategoryHiddenCheck( loc_id, category_id )

	if self:CategoryBar( loc_id, category_id ) and self:CategoryBar( loc_id, category_id ) < 0 then
		return true
	else
		return false
	end

end

function ARKINV:CategoryHiddenToggle( loc_id, category_id )
	self:CategoryLocationSet( loc_id, category_id, 0 - self:CategoryLocationGet( loc_id, category_id ) )
end

function ARKINV:CategoryNameGet( category_id )

	for _, v in pairs( ARKINV_G.CATEGORY ) do
		if category_id == v.id then
			return v.name, false
		end
	end

	local restore = false
	
	if category_id < 0 then
		restore = true
	end
	
	return ( table.concat( { "UNKNOWN CATEGORY: ", category_id } ) ), restore
	
end

function ARKINV:CategoryGenerate()

	categories = {
		["SYSTEM"] = ARKINV_G.CATEGORY_SYSTEM,
		["SKILL"] = ARKINV_G.CATEGORY_SKILL,
		["CLASS"] = ARKINV_G.CATEGORY_CLASS,
		["EMPTY"] = ARKINV_G.CATEGORY_EMPTY,
		["OTHER"] = ARKINV_G.CATEGORY_OTHER,
		["RULE"] = self.db.account.option.rule,
	}
	
	local n
	
	ARKINV_G.CATEGORY = { }

	for t, d in pairs( categories ) do
		for k, v in pairs( d ) do
	
			local n
			
			if t == "RULE" then
				-- n = table.concat( { ARKINV_L["CATEGORY_" .. t], ": ", v.name } )
				n = k .. ". " .. v.name
			else
				-- n = table.concat( { ARKINV_L["CATEGORY_" .. t], ": ", v } )
				n = v
			end
			
			tinsert( ARKINV_G.CATEGORY, { ["id"]=k, ["name"]=n, ["type"]=t } )
			
		end
	end

end

function ARKINV:CategoryBarInsert( loc_id, barnum )

	for k, v in pairs( self:OptionLocalGet( loc_id, { "rule" } ) ) do
		if v >= barnum then
			self:CategoryLocationSet( loc_id, k, self:CategoryLocationGet( loc_id, k ) + 1 )
		end
	end

end

function ARKINV:CategoryBarRemove( loc_id, barnum )

	local def_loc = self:CategoryLocationGet( loc_id, ARKINV_G.CATEGORY_ID_DEFAULT ) -- bar the DEFAULT category is currently on
	
	for k, v in pairs( self:OptionLocalGet( loc_id, { "rule" } ) ) do
	
		if v > barnum then
			self:CategoryLocationSet( loc_id, k, self:CategoryLocationGet( loc_id, k ) - 1 )
		elseif v == barnum then
			
			if k == ARKINV_G.CATEGORY_ID_DEFAULT then
				-- if the DEFAULT category was on the bar then move it to bar 1
				self:CategoryLocationSet( loc_id, k, 1 )
			else
				-- erase the location, setting it back to the same as DEFAULT
				self:CategoryLocationSet( loc_id, k, nil )
			end
			
		end
		
	end

end

function ARKINV:CategoryBarClear( loc_id, barnum )

	for k, v in pairs( self:OptionLocalGet( loc_id, { "rule" } ) ) do
		if v == barnum then
			if k ~= ARKINV_G.CATEGORY_ID_DEFAULT then
				-- erase the location, setting it back to the same as DEFAULT
				self:CategoryLocationSet( loc_id, k, nil )
			end
		end
	end

end

function ARKINV:ItemCategoryID( cat )

	--self:Debug( { "ItemCategoryID( ", cat, " ) start" } )

	for _, v in pairs( ARKINV_G.CATEGORY ) do
		if cat == v.name then
			return v.id
		end
	end
	
	return ARKINV_G.CATEGORY_ID_DEFAULT -- default
	
end


function ARKINV:ItemCategoryGetDefaultActual( i, bt, bagnum, slotnum )

	-- local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	local info_name, _, info_rarity, _, _, info_type, info_subtype, _, info_location = GetItemInfo( i.h )
	
	-- trash, it's always trash
	if info_rarity == 0 then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_TRASH"] )
	end

	
	-- projectiles
	if info_location == "INVTYPE_AMMO" or info_type == ARKINV_L["WOW_ITEM_TYPE_PROJECTILE"] then
	
		if info_subtype == ARKINV_L["WOW_ITEM_TYPE_PROJECTILE_BULLET"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_BULLET"] )
		elseif info_subtype == ARKINV_L["WOW_ITEM_TYPE_PROJECTILE_ARROW"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_ARROW"] )
		end

		return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE"] )
		
	end
	
	-- bags / containers
	if info_location == "INVTYPE_BAG" or self:PT_ItemInSets( i.h, "Bag" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_CONTAINER"] )
	end

	-- soulbound equipment (armour, weapons, trinkets, tabards, etc, etc)
	if i.sb and info_location ~= "" then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EQUIPMENT_SOULBOUND"] )
	end

	-- soul shards
	if self:PT_ItemInSets( i.h, "Container.ItemsInType.Soul Shard" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULSHARD"] )
	end

	-- mounts
	if self:PT_ItemInSets( i.h, "Misc.Mount" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_MOUNT"] )
	end

	-- reputation hand-ins
	if self:PT_ItemInSets( i.h, "Reputation.Turnin" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_REPUTATION"] )
	end

	-- quest items
	if info_type == ARKINV_L["WOW_ITEM_TYPE_QUEST"] or self:PT_ItemInSets( i.h, "QuestMats" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_QUEST"] )
	end

	-- keys
	if info_type == ARKINV_L["WOW_ITEM_TYPE_KEY"] or self:PT_ItemInSets( i.h, "Misc.Key" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_KEY"] )
	end
	
	-- food
	if self:PT_ItemInSets( i.h, "Consumable.Food.Edible" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_FOOD"] )
	end

	-- drink
	if self:PT_ItemInSets( i.h, "Consumable.Water" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_DRINK"] )
	end

	-- potions (health)
	if 
	self:PT_ItemInSets( i.h, "Consumable.Potion.Recovery.Healing,Consumable.Warlock.Healthstone" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION_HEAL"] )
	end
	
	-- potions (mana)
	if self:PT_ItemInSets( i.h, "Consumable.Potion.Recovery.Mana,Consumable.Mage.Mana Stone" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION_MANA"] )
	end
	
	-- potions (everything else)
	if self:PT_ItemInSets( i.h, "Consumable.Potion" ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION"] )
	end

	-- skills - cycle through the users skills and allocate items to those profressions first
	for k in self:spairs( ARKINV_G.PLAYER_SKILLS, function(a,b) return ARKINV_G.PLAYER_SKILLS[a] < ARKINV_G.PLAYER_SKILLS[b] end ) do
	
		if self:PT_ItemInSets( i.h, ARKINV_L["PT_SKILL_" .. k] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_" .. k] )
		end

	end

	-- skills - do the rest
	for w in string.gmatch( "ALCHEMY,BLACKSMITHING,COOKING,ENCHANTING,ENGINEERING,FIRST_AID,JEWELCRAFTING,LEATHERWORKING,TAILORING", "[^,]+" ) do
		if self:PT_ItemInSets( i.h, ARKINV_L["PT_SKILL_" .. w] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_" .. w] )
		end
	end

	
	-- class items (this characters class first)
	local pt_class = self.db.account.cache.who[ARKINV_G.ME].class
	if self:PT_ItemInSets( i.h, ARKINV_L["PT_CLASS_" .. pt_class] ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_" .. pt_class] )
	end

	-- class items
	for w in string.gmatch( "Druid,Hunter,Mage,Paladin,Priest,Rogue,Shaman,Warlock,Warrior", "[^,]+" ) do
		if self:PT_ItemInSets( i.h, "Reagent.Class." .. w ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_" .. string.upper( w )] )
		end
	end


	-- soulbound items that need to be categorised somewhere else other than soulbound
	if i.sb then
	
		-- pets (non combat)
		if self:PT_ItemInSets( i.h, "Misc.Minipet" ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PET_NONCOMBAT"] )
		end

		return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULBOUND"] )
		
	end

	
	-- non soulbound weapons and armour
	if info_location and info_location ~= "" then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EQUIPMENT"] )
	end


	-- recipes
	if info_type == ARKINV_L["WOW_ITEM_TYPE_RECIPE"] then
		if 1 == 2 then
			-- ignore this for the moment
			for w in string.gmatch( "ALCHEMY,BLACKSMITHING,COOKING,ENCHANTING,ENGINEERING,FIRST_AID,JEWELCRAFTING,LEATHERWORKING,TAILORING", "[^,]+" ) do
				if info_subtype == ARKINV_L[w] then
					return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_" .. w] )
				end
			end
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_RECIPE"] )
		end	
	end
	
	
	-- fallback when not in periodic table sets

	
	-- setup tooltip for scanning
	ARKINV_G.StealthTooltip:SetHyperlink( i.h )
	
	-- skill requirement (but not armour or weapons) from tooltip
	local _, _, req = ARKINV_G.StealthTooltip:Find( ARKINV_L["WOW_TOOLTIP_REQUIRES"], false, false, true )
	
	if req and not ( info_type == ARKINV_L["WOW_ITEM_TYPE_ARMOR"] or info_type == ARKINV_L["WOW_ITEM_TYPE_WEAPON"] ) then
	
		if strfind( req, ARKINV_L["WOW_SKILL_ALCHEMY"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_ALCHEMY"] )
		end

		if strfind( req, ARKINV_L["WOW_SKILL_BLACKSMITHING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_BLACKSMITHING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_COOKING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_COOKING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_ENCHANTING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_ENCHANTING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_ENGINEERING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_ENGINEERING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_FIRST_AID"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_FIRST_AID"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_FISHING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_FISHING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_HERBALISM"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_HERBALISM"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_JEWELCRAFTING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_JEWELCRAFTING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_LEATHERWORKING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_LEATHERWORKING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_MINING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_MINING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_SKINNING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_SKINNING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_TAILORING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_TAILORING"] )
		end
		
		if strfind( req, ARKINV_L["WOW_SKILL_RIDING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_MOUNT"] )
		end
		
	end

	-- class via tooltip
	local _, _, req = ARKINV_G.StealthTooltip:Find( ARKINV_L["WOW_TOOLTIP_CLASS"], false, false, true )
	
	if req then
		for w in string.gmatch( "DRUID,HUNTER,MAGE,PALADIN,PRIEST,ROGUE,SHAMAN,WARLOCK,WARRIOR", "[^,]+" ) do
			if strfind( req, ARKINV_L["WOW_CLASS_" .. w] ) then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_" .. w] )
			end
		end
	end
	
	if info_type == ARKINV_L["WOW_ITEM_TYPE_CONSUMABLE"] then

		if ARKINV_G.StealthTooltip:Contains( ARKINV_L["WOW_TOOLTIP_POTION_HEAL"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION_HEAL"] )
		end

		if ARKINV_G.StealthTooltip:Contains( ARKINV_L["WOW_TOOLTIP_POTION_MANA"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION_MANA"] )
		end
		
		if ARKINV_G.StealthTooltip:Contains( ARKINV_L["WOW_TOOLTIP_FOOD"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_FOOD"] )
		end
		
		if ARKINV_G.StealthTooltip:Contains( ARKINV_L["WOW_TOOLTIP_DRINK"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_DRINK"] )
		end

		if strfind( info_name, ARKINV_L["WOW_TOOLTIP_POTION"] ) or strfind( info_name, ARKINV_L["WOW_TOOLTIP_ELIXIR"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_POTION"] )
		end
		
		return self:ItemCategoryID( ARKINV_L["CATEGORY_CONSUMABLE"] )
		
	end
	
	
	if info_type == ARKINV_L["WOW_ITEM_TYPE_MISCELLANEOUS"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_MISCELLANEOUS"] )
	end
	
	if info_type == ARKINV_L["WOW_ITEM_TYPE_REAGENT"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_REAGENT"] )
	end

	if info_type == ARKINV_L["WOW_ITEM_TYPE_TRADE_GOODS"] then

		if info_subtype == ARKINV_L["WOW_ITEM_TYPE_TRADE_GOODS_DEVICES"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADE_GOODS_DEVICES"] )
		elseif info_subtype == ARKINV_L["WOW_ITEM_TYPE_TRADE_GOODS_EXPLOSIVES"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADE_GOODS_EXPLOSIVES"] )
		elseif info_subtype == ARKINV_L["WOW_ITEM_TYPE_TRADE_GOODS_PARTS"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADE_GOODS_PARTS"] )
		end

		return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADE_GOODS"] )
	
	end

	
	-- fallback for any item not categorised
	return self:ItemCategoryID( ARKINV_L["CATEGORY_DEFAULT"] )
	
end

function ARKINV:ItemCategoryGetDefaultEmpty( bt, bagnum )

	local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	local loc_id = self:BagLocation( bagnum )
	local clump = self:OptionLocalGet( loc_id, { "slot", "empty", "clump" } )
	
	if bt == ARKINV_G.SLOT_BAG then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_BAG"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_PROJECTILE_BULLET then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_BULLET"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_PROJECTILE_ARROW then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_ARROW"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_KEY then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_KEY"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_KEY"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_SOULSHARD then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULSHARD"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_SOULSHARD"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_HERB then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_HERBALISM"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_HERB"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_ENCHANTING then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_ENCHANTING"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_ENCHANTING"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_ENGINEERING then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_ENGINEERING"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_ENGINEERING"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_GEM then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_JEWELCRAFTING"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_GEM"] )
		end
	end
	
	if bt == ARKINV_G.SLOT_MINING then
		if clump then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SKILL_MINING"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_MINING"] )
		end
	end
	
	if clump then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY"] )
	else
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_UNKNOWN"] )
	end

end

function ARKINV:ItemCategoryGetDefault( i, bt, bagnum, slotnum )
	
	local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }
	
	if not i.h then
		return self:ItemCategoryGetDefaultEmpty( bt, bagnum )
	end

	cid = self:GetItemCacheID( i )
	
	-- if the value has been cached then use it
	if not ARKINV_G.CACHE_CATEGORY_DEFAULT[cid] then
		ARKINV_G.CACHE_CATEGORY_DEFAULT[cid] = self:ItemCategoryGetDefaultActual( i, bt, bagnum, slotnum )
	end
	
	return ARKINV_G.CACHE_CATEGORY_DEFAULT[cid]

end


function ARKINV:ItemCategoryGetRule( i, bt, bagnum, slotnum )

	-- local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	-- check rules
	for rulenum in self:spairs( self.db.account.option.rule, function(a,b) return self.db.account.option.rule[a].order < self.db.account.option.rule[b].order end ) do
		
		local a, em = self:RuleAppliesToItem( rulenum, i, bagnum, slotnum )
		
		if em == nil then
		
			if a == true then
				return rulenum
			end
		
		else
		
			self:Print( RED_FONT_COLOR_CODE .. "Rule " .. rulenum .. " is now flagged as damaged and will no longer be used until fixed" )
			
			self.db.account.option.rule[rulenum].damaged = true
			
			self:Print( em )
			
		end
		
	end

	-- self:PrintPlus( "ItemCategoryGet() end", debuginfo )

	return nil

end

function ARKINV:ItemCategoryGet( i, bt, bagnum, slotnum )
	-- returns category, [ default category]
	
	--local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }
	
	local dc = self:ItemCategoryGetDefault( i, bt, bagnum, slotnum )
	
	cid = self:GetItemCacheID( i )
	
	-- if the value has been cached then use it
	if not ARKINV_G.CACHE_CATEGORY_CURRENT[cid] then
		ARKINV_G.CACHE_CATEGORY_CURRENT[cid] = self:ItemCategoryGetRule( i, bt, bagnum, slotnum )
	end

	if ARKINV_G.CACHE_CATEGORY_CURRENT[cid] then
		return ARKINV_G.CACHE_CATEGORY_CURRENT[cid], dc
	else
		return dc, nil
	end
	
end


function ARKINV:ItemCategorySet( tblItem, category_id )
	-- set cat to nil to reset
	self.db.profile.option.global.category.item[tblItem.id] = category_id
	self:ItemCategoryReload( tblItem )
end

function ARKINV:ItemCategoryReload( tblItem )

	--self:Debug( "ItemCategoryReload() start" )

	local c = nil
	local cd = nil
	
	if tblItem.id then
		for name, who in pairs( self.db.account.cache.who ) do
			for _, loc in pairs( who.loc ) do
				for bagnum, bag in pairs( loc.bag ) do
					for slotnum, slot in pairs( bag.slot ) do
						if slot.id == tblItem.id then
							if not c then
								-- only get the category for the first match, use the same values for the rest
								c, cd = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
							end
							slot["cat"] = c
							slot["catdef"] = cd
						end
					end
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReload() end" )
	
end

function ARKINV:ItemCategoryReloadEmpty()

	--self:Debug( "ItemCategoryReloadEmpty() start" )
	
	for name, who in pairs( self.db.account.cache.who ) do
		for _, loc in pairs( who.loc ) do
			for bagnum, bag in pairs( loc.bag ) do
				for slotnum, slot in pairs( bag.slot ) do
					if not slot.h then
						slot["cat"], slot["catdef"] = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
					end
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReloadEmpty() end" )
	
end

function ARKINV:ItemCategoryReloadAll()

	-- regenerates the category and default category for every item

	--self:Debug( "ItemCategoryReloadAll() start" )

	for name, who in pairs( self.db.account.cache.who ) do
		for _, loc in pairs( who.loc ) do
			for bagnum, bag in pairs( loc.bag ) do
				for slotnum, slot in pairs( bag.slot ) do
					slot["cat"], slot["catdef"] = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReloadAll() end" )
	
end

function ARKINV:ItemCategoryResetDefault()

	for j in pairs( self.db.profile.option.global.category.item ) do
		self.db.profile.option.global.category.item[j] = nil
	end

end

function ARKINV:ReverseName( n )

	if n and type( n ) == "string" then

		local s = { }

		for w in string.gmatch( n, "%S+" ) do
			tinsert( s, 1, w )
		end

		return table.concat( s, " " )
		
	end

end

function ARKINV:CalculateBars( loc_id )

	--self:Debug( { GREEN_FONT_COLOR_CODE, "CalculateBars( ", loc_id, " ) start " } )

	if not ARKINV_G.LOCATION[loc_id].rebuild then
		--self:Debug( { GREEN_FONT_COLOR_CODE, "CalculateBars( ", loc_id, " ) aborted, not needed " } )
		return
	end
	
	
	local current_player = ARKINV_G.LOCATION[loc_id].player
	
	self.db.account.cache.who[current_player].loc[loc_id].bar = { }
	self.db.account.cache.who[current_player].loc[loc_id].bar_count = 1
	
	local barnum

	-- load the inventory into their respective bars
	for bagnum, bag in pairs( self.db.account.cache.who[current_player].loc[loc_id].bag ) do
	
		for slotnum, slot in pairs( bag.slot ) do
		
			barnum = self:CategoryLocationGet( loc_id, slot.cat )
			--self:Debug( { "loc_id =", loc_id, ", category = ", slot.cat, ", barnum = ", barnum } )
	
			if barnum > 0 or ARKINV_G.MODE.EDIT or self:OptionLocalGet( loc_id, { "slot", "ignorehidden" } ) then  -- hidden categories reside on negative bar numbers so they don't get displayed (show them if in edit mode or the user wants us to ignore the hidden flag)
	
				barnum = abs( barnum )
	
				-- create the bar
				if not self.db.account.cache.who[current_player].loc[loc_id].bar[barnum] then
					self.db.account.cache.who[current_player].loc[loc_id].bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 0, ["width"] = 0, ["height"] = 0, ["frame"] = 0, ["ghost"] = false }
				end
		
				-- add the item to the bar
				tinsert( self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].item, { ["bag"] = bagnum, ["slot"] = slotnum } )
			
				-- increment the bars item count
				self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count = self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count + 1
			
				-- keep track of the last bar used
				if barnum > self.db.account.cache.who[current_player].loc[loc_id].bar_count then
					self.db.account.cache.who[current_player].loc[loc_id].bar_count = barnum
				end

				--self:Debug( { "bag[", bagnum, "], slot[", slotnum, "], cat[", slot.cat, "], bar[", barnum, "], id=[", self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].id, "]" } )
				
			end
			
		end
		
	end

	
	-- get highest used bar
	local cats = self:OptionLocalGet( loc_id, { "rule" } )
	for cat_id, barnum in pairs( cats ) do
		if barnum > self.db.account.cache.who[current_player].loc[loc_id].bar_count then
			self.db.account.cache.who[current_player].loc[loc_id].bar_count = barnum
		end
	end
	
	-- round up to a full number of bars per row
	self.db.account.cache.who[current_player].loc[loc_id].bar_count = ceil( self.db.account.cache.who[current_player].loc[loc_id].bar_count / self:OptionLocalGet( loc_id, { "bar", "per" } ) ) * self:OptionLocalGet( loc_id, { "bar", "per" } )

	
	-- update the maximum number of bar frames used so far
	if self.db.account.cache.who[current_player].loc[loc_id].bar_count > ARKINV_G.LOCATION[loc_id].bar_max then
		ARKINV_G.LOCATION[loc_id].bar_max = self.db.account.cache.who[current_player].loc[loc_id].bar_count
	end

	
	-- if we're in edit mode then create all missing bars and add a ghost item to every bar
	if ARKINV_G.MODE.EDIT or self:OptionLocalGet( loc_id, { "bar", "showempty" } ) then
	
		--self:Debug( "edit mode - adding ghost bars" )
		for barnum = 1, self.db.account.cache.who[current_player].loc[loc_id].bar_count do
				
			if not self.db.account.cache.who[current_player].loc[loc_id].bar[barnum] then
			
				-- create a ghost bar
				self.db.account.cache.who[current_player].loc[loc_id].bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 1, ["width"] = 0, ["height"] = 0, ["frame"] = 0, ["ghost"] = true }
				
			else
	
				-- add a ghost item to the bar by incrementing the bars item count
				self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count = self.db.account.cache.who[current_player].loc[loc_id].bar[barnum].count + 1
				
			end
			
		end
		
	end

	--self:Debug( { GREEN_FONT_COLOR_CODE, "CalculateBars( ", loc_id, " ) end - " } )
	
end

function ARKINV:CalculateContainer( loc_id )

	--self:Debug( { GREEN_FONT_COLOR_CODE, "CalculateContainer( ", loc_id, " ) start " } )

	if not ARKINV_G.LOCATION[loc_id].rebuild then
		--self:Debug( { GREEN_FONT_COLOR_CODE, "CalculateContainer( ", loc_id, " ) aborted, not needed " } )
		return
	end


	local current_player = ARKINV_G.LOCATION[loc_id].player

	self.db.account.cache.who[current_player].loc[loc_id].container = { ["row"] = { } }
	
	local bpr = self:OptionLocalGet( loc_id, { "bar", "per" } )
	local rownum = 0
	local bf = 1 -- bar frame, allocated to each bar as it's calculated (uses less frames this way)
	
	--self:Debug( { "container has ", self.db.account.cache.who[current_player].loc[loc_id].bar_count, " bars" } )
	--self:Debug( { "container set for ", bpr, " bars per row" } )
	
	
	if ARKINV_G.MODE.EDIT == false and self:OptionLocalGet( loc_id, { "bar", "compact" } ) then
	
		--self:Debug( { "compact bars enabled" } )
	
		local bc = 0  -- number of bars currently in this row
		local vr = { }  -- virtual row - holds a list of bars for this row

		for j = 1, self.db.account.cache.who[current_player].loc[loc_id].bar_count do
		
			--self:Debug( "bar=" .. j )
		
			if self.db.account.cache.who[current_player].loc[loc_id].bar[j] then
				if self.db.account.cache.who[current_player].loc[loc_id].bar[j].count > 0 then
					--self:Debug( "assignment: bar=" .. j .. ", frame=" .. bf )
					self.db.account.cache.who[current_player].loc[loc_id].bar[j]["frame"] = bf
					bf = bf + 1
					bc = bc + 1
					tinsert( vr, self.db.account.cache.who[current_player].loc[loc_id].bar[j] )
				else
					--self:Debug( "bar " .. j .. " has no items" )
				end
			else
				--self:Debug( "bar " .. j .. " does not exist" )
			end
		
			if bc > 0 and ( bc == bpr or j == self.db.account.cache.who[current_player].loc[loc_id].bar_count ) then
		
				rownum = rownum + 1
				if not self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] then
					self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] = { }
				end
			
				self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum].bar = vr
				
				--self:Debug( "row " .. rownum .. " created" )
				
				bc = 0
				vr = { }

			end		
		
		end
	
	else
	
		for j = 1, self.db.account.cache.who[current_player].loc[loc_id].bar_count, bpr do
		
			local bc = 0  -- number of bars currently in this row
			local vr = { }  -- virtual row - holds a list of bars for this row

			for b = 1, bpr do
				if self.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1] then
					if self.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1].count > 0 then
						--self:Debug( "assignment: bar=" .. j+b-1 .. ", frame=" .. bf )
						self.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1]["frame"] = bf
						bf = bf + 1
						bc = bc + 1
						tinsert( vr, self.db.account.cache.who[current_player].loc[loc_id].bar[j+b-1] )
					else
						--self:Debug( "bar " .. j+b-1 .. " has no items" )
					end
				else
					--self:Debug( "bar " .. j+b-1 .. " does not exist" )
				end
			end
		
			--self:Debug( "row " .. rownum .. " allocated " .. bc .. " bars" )
		
			if bc > 0 then
		
				rownum = rownum + 1
				if not self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] then
					self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum] = { }
				end
			
				self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum].bar = vr

			end

		end
		
	end

	
	-- fit the bars into the row

	local rmw = self:OptionLocalGet( loc_id, { "window", "width" } )  -- row max width
	local rcw = 0 -- row current width
	local rch = 1 -- row current height
	local rmh = 0 -- row max height
		
	for rownum, row in ipairs( self.db.account.cache.who[current_player].loc[loc_id].container.row ) do
			
		for bagnum, bar in ipairs( row.bar ) do

			--self:Debug( "row=" .. rownum .. ", bag=" .. bagnum )
			
			bar.width = floor( bar.count / rmw )
			if bar.width < 1 then
				bar.width = 1
			end
			
			bar.height = ceil( bar.count / bar.width )
				
			if bar.height > rmh then
				rmh = bar.height
			end
				
		end
			
		if rmh > 1 then

			repeat
			
				rcw = 0
				rmh = 0
				rmb = 0
				
				-- find bar with highest height
				for barnum, bar in ipairs( row.bar ) do
					if bar.height > rmh then
						rmh = bar.height
						rmb = barnum
					end
				end

				-- increase that bars width by one
				row.bar[rmb].width = row.bar[rmb].width + 1
				
				-- and recalcualte it's new height
				row.bar[rmb].height = ceil( row.bar[rmb].count / row.bar[rmb].width )
				
				-- and see if that all fits
				rcw = self:tableSum( row.bar, function( a ) return a.width end )
				
				rmh = self:tableMax( row.bar, function( a ) return a.height end )
					
				-- exit if the width fits or the max height is 1
			until rcw >= rmw or rmh == 1
			
		end
			
		--self:Debug( "maximum height for row " .. rownum .. " was " .. rmh )
		for _, bar in pairs( row.bar ) do
			-- set height of all bars in the row to the maximum height used (looks better)
			bar.height = rmh
			
			if bar.ghost or ARKINV_G.MODE.EDIT or self:OptionLocalGet( loc_id, { "bar", "showempty" } ) then
				-- remove the ghost item from the count
				bar.count = bar.count - 1
			end
		end
		
	end
	

	--self:Debug( { GREEN_FONT_COLOR_CODE, "CalculateContainer( ", loc_id, " ) end - " } )

end


function ARKINV:FrameUpdate( loc_id )

	local window = getglobal( ARKINV_G.GUI_NAME .. loc_id )
	
	local current_player = ARKINV_G.LOCATION[loc_id].player
	
	-- update the empty slot count
	local empty = { }
	for k, bag in pairs( self.db.account.cache.who[current_player].loc[loc_id].bag ) do
		if not empty[bag.type] then
			empty[bag.type] = { ["count"] = 0, ["empty"] = 0, ["type"] = bag.type }
		end
		empty[bag.type].count = empty[bag.type].count + bag.count
		empty[bag.type].empty = empty[bag.type].empty + bag.empty
	end

	local ee = self:tableSum( empty, function( a ) return a.empty end )
	local ts = self.db.account.cache.who[current_player].loc[loc_id].slot_count
	
	local y = ""
	if ee == 0 then
		y = RED_FONT_COLOR_CODE .. ARKINV_L["STATUS_FULL"]
	else
		y = y .. ee .. "/" .. ts
	end

	if ts == 0 then
		y = RED_FONT_COLOR_CODE .. ARKINV_L["STATUS_NO_DATA"]
	end

	
	if ts ~= 0 and self:tableElements( empty ) > 1 then
		local z = 0
		local x
		y = y .. "  -  "
		for t, e in self:spairs( empty, function(a,b) return empty[a].type < empty[b].type end ) do
			z = z + 1
			--x = e.empty .. "/" .. e.count .. " " .. self:BagTypeText( t )
			x = e.empty .. " " .. self:OptionLocalGet( loc_id, { "slot", "data", t, "name" } )
			if e.empty == 0 then
				x = RED_FONT_COLOR_CODE .. x .. FONT_COLOR_CODE_CLOSE
			end
			
			if z == 1 then
				y = y .. x
			else
				y = y .. ", " .. x
			end
			
		end
	end

	getglobal( window:GetName() .. "StatusText" ):SetText( y )
	
	
	-- set the size of the window
	local h = 0
	h = h + getglobal( window:GetName() .. "Title" ):GetHeight()
	h = h + getglobal( window:GetName() .. "Container" ):GetHeight()
	h = h + getglobal( window:GetName() .. "BagChanger" ):GetHeight()
	h = h + getglobal( window:GetName() .. "Status" ):GetHeight()
	window:SetHeight( h )
	
	window:SetWidth( self.db.account.cache.who[current_player].loc[loc_id].container.width )
	
end

function ARKINV:FramePosition( obj )

end


function ARKINV:GenerateItems( loc_id, barnum, bar )

	if bar.count == 0 or bar.ghost then
		return
	end
	
	local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }
	--self:Debug( { GREEN_FONT_COLOR_CODE, "GenerateItems( ", bar_frame:GetName(), " ) start " } )

	local frame = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "Container" )
	local bar_frame = frame:GetName() .. "Bar" .. bar.frame
	local current_player = ARKINV_G.LOCATION[loc_id].player
	local i


	-- sort the items in the bar
	if ARKINV_G.LOCATION[loc_id].redraw and ARKINV_G.LOCATION[loc_id].rebuild then
	
		local bagnum, slotnum
		local s = { }
		
		for j = 1, bar.count do
	
			bagnum = bar.item[j].bag
			slotnum = bar.item[j].slot

			bar.item[j].sort = self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].slot[slotnum].sort or ""
			
		end
		
		sort( bar.item, function( a, b ) return a.sort > b.sort end )

	end

	local pad_slot = self:OptionLocalGet( loc_id, { "slot", "pad" } )
	local pad_bar = self:OptionLocalGet( loc_id, { "bar", "pad", "internal" } )
	local col = bar.width
	local obj, locked, readable, bnum
	
	-- build the items in the bar
	for j = 1, bar.count do
	
		i = self.db.account.cache.who[current_player].loc[loc_id].bag[bar.item[j].bag].slot[bar.item[j].slot]
		
		name = self:ContainerItemNameGet( loc_id, bar.item[j].bag, bar.item[j].slot )
		obj = getglobal( name )
		if not obj then
			error( "slot frame [" .. name .. "] does not exist" )
		end
		
		if ARKINV_G.LOCATION[loc_id].rebuild then

			-- anchor first item to bar frame
			if ( j == 1 ) then
				obj:SetPoint( "BOTTOMRIGHT", bar_frame, "BOTTOMRIGHT", 0 - pad_bar, pad_bar )
			else
				if ( mod( ( j - 1 ), col ) == 0 ) then
					-- next row, anchor to first item in previous row
					obj:SetPoint( "BOTTOMRIGHT", self:ContainerItemNameGet( loc_id, bar.item[j-col].bag, bar.item[j-col].slot ), "TOPRIGHT", 0, pad_slot )
				else
					-- anchor to last one
					obj:SetPoint( "BOTTOMRIGHT", self:ContainerItemNameGet( loc_id, bar.item[j-1].bag, bar.item[j-1].slot ), "BOTTOMLEFT", 0 - pad_slot, 0 )
				end
			end
	
			SetItemButtonTexture( obj, self:GetItemTexture( i.h ) )
		
		end

		SetItemButtonCount( obj, i.count )
	
		-- item locked, needs to only happen for online items
		if not ARKINV_G.LOCATION[loc_id].offline then
			local _, _, locked, _, readable = GetContainerItemInfo( bar.item[j].bag, bar.item[j].slot )
			obj.readable = readable
			SetItemButtonDesaturated( obj, locked, 0.5, 0.5, 0.5 )
		else
			obj.readable = false
		end

		if ARKINV_G.LOCATION[loc_id].offline and self.db.account.option.offline.fade then
			obj:SetAlpha( ARKINV_G.FADE_ALPHA )
		else
			obj:SetAlpha( 1 )
		end
		
		-- item rarity coloured borders
		if i.q > 0 and self:OptionLocalGet( loc_id, { "slot", "border" } ) then
			local r, g, b = GetItemQualityColor( i.q )
			getglobal( obj:GetName() .. "ArkQualityBorder" ):SetBackdropBorderColor( r, g, b, 1 )
		else
			getglobal( obj:GetName() .. "ArkQualityBorder" ):SetBackdropBorderColor( 0.5, 0.5, 0.5, 1 )
		end


		if i.h then
			
			ContainerFrame_UpdateCooldown( bar.item[j].bag, obj )
			obj.hasItem = 1
			
			-- new indicator
			local nt = getglobal( obj:GetName() .. "ArkNewText" )
			if self.db.account.option.newitem.show then
				nt:SetTextColor( self.db.account.option.newitem.colour.r, self.db.account.option.newitem.colour.g, self.db.account.option.newitem.colour.b )
				if i.new == ARKINV_G.ITEM_CHANGE.NONE then
					nt:Hide()
				elseif i.new == ARKINV_G.ITEM_CHANGE.NEW then
					nt:SetText( "NEW" )
					nt:Show()
				elseif i.new == ARKINV_G.ITEM_CHANGE.INCREASE then
					nt:SetText( "+++" )
					nt:Show()
				elseif i.new == ARKINV_G.ITEM_CHANGE.DECREASE then
					nt:SetText( "- - -" )
					nt:Show()
				end
			else
				nt:Hide()
			end

		else
			
			-- empty slot colours
			local bt = self.db.account.cache.who[current_player].loc[loc_id].bag[bar.item[j].bag].type
			local colour = self:OptionLocalGet( loc_id, { "slot", "data", bt, "colour" } )

			-- icon or coloured background
			if self:OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) then
				SetItemButtonTexture( obj, "Interface\\PaperDoll\\UI-Backpack-EmptySlot" )
			else
				SetItemButtonTexture( obj, "Interface\\Buttons\\WHITE8X8" )
				SetItemButtonTextureVertexColor( obj, colour.r * 0.25, colour.g * 0.25, colour.b * 0.25 )
			end

			-- empty borders
			if self:OptionLocalGet( loc_id, { "slot", "empty", "border" } ) then
				getglobal( obj:GetName() .. "ArkQualityBorder" ):SetBackdropBorderColor( colour.r, colour.g, colour.b, 1 )
			else
				getglobal( obj:GetName() .. "ArkQualityBorder" ):SetBackdropBorderColor( 0.5, 0.5, 0.5, 1 )
			end

			getglobal( obj:GetName() .. "Cooldown"):Hide()
			obj.hasItem = nil
			
			-- new indicator
			getglobal( obj:GetName() .. "ArkNewText" ):Hide()

		end


		obj:Show()
	
	end

	
	--self:Debug( { GREEN_FONT_COLOR_CODE, "GenerateItems() end" }, debuginfo )
	
end

function ARKINV:GenerateBarBorder( name )

	local loc_id, _, _, current_player = self:ItemButton_Details( name )
	
	for rownum, row in ipairs( self.db.account.cache.who[current_player].loc[loc_id].container.row ) do
		for barnum, bar in ipairs( row.bar ) do
			obj = getglobal( name .. "Bar" .. bar.frame )
			
			if self:OptionLocalGet( loc_id, { "bar", "border" } ) then
				local colour = self:OptionLocalGet( loc_id, { "bar", "colour", "border" } )
				obj:SetBackdropBorderColor( colour.r, colour.g, colour.b, 1 )
			else
				obj:SetBackdropBorderColor( 0, 0, 0, 0 )
			end


			if ARKINV_G.MODE.EDIT then
				obj:SetBackdropBorderColor( 1, 0, 0, 1 )
				getglobal( obj:GetName() .. "Background" ):SetTexture( 1, 0, 0, 0.1 )
				getglobal( obj:GetName() .. "Edit" ):Show()
				obj:Show()
			else
				local colour = self:OptionLocalGet( loc_id, { "bar", "colour", "background" } )
				getglobal( obj:GetName() .. "Background" ):SetTexture( colour.r, colour.g, colour.b, colour.a )

				-- hide the bar frames if the option is enabled (for a bug with bars coming over the top of the items)
				if not self:OptionLocalGet( loc_id, { "bar", "hide" } ) then
					obj:Show()
				end
				
			end
			
		end
	end
	
end



function ARKINV:ClearItemCache()
	self:CategoryGenerate()
	self:BagTaintAll()
	ARKINV_G.CACHE_CATEGORY_CURRENT = { }
end

function ARKINV:ContainerGenerateRedrawAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		ARKINV_G.LOCATION[loc_id].redraw = true
		self:ContainerGenerateRebuild( loc_id )
	end
end

function ARKINV:ContainerGenerateRebuildAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:ContainerGenerateRebuild( loc_id )
	end
end

function ARKINV:ContainerGenerateRebuild( loc_id )
	ARKINV_G.LOCATION[loc_id].rebuild = true
	self:ContainerGenerateRefresh( loc_id )
end


function ARKINV:ContainerGenerateRefreshAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:ContainerGenerateRefresh( loc_id )
	end
end

function ARKINV:ContainerGenerateRefresh( loc_id )
	ARKINV_G.LOCATION[loc_id].refresh = true
	self:ContainerGenerate( loc_id )
end


function ARKINV:ContainerGenerateAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:ContainerGenerate( loc_id )
	end
end

function ARKINV:ContainerGenerate( loc_id )

	local debuginfo = { ["m"]=gcinfo(), ["t"]=GetTime() }

	if not loc_id then return end
	
	local frame = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "Container" )

	if not frame then return end

	-- exit if window isn't displayed
	if not frame:IsVisible() then return end

	--self:PrintPlus( { GREEN_FONT_COLOR_CODE, "ContainerGenerate( ", loc_id, " ) start" } )

	local current_player = ARKINV_G.LOCATION[loc_id].player
	
	-- are we online or offline?
	if current_player == ARKINV_G.ME then
		ARKINV_G.LOCATION[loc_id].offline = false
		if loc_id == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE.BANK == false then
			ARKINV_G.LOCATION[loc_id].offline = true
		end
	else
		ARKINV_G.LOCATION[loc_id].offline = true
	end


	
	
	-- hide the changer frame if it's not needed, needs to be done first
	obj = getglobal( frame:GetParent():GetName() .. "BagChanger" )
	if self.db.account.option.framehide.changer or ARKINV_G.LOCATION[loc_id].offline then
		
		obj:Hide()
		obj:SetHeight( 1 )

	else

		if loc_id == ARKINV_G.LOCATION_BAG or ( loc_id == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE.BANK ) then
			obj:SetHeight( 58 )
			obj:Show()
		end

	end

	
	
	
	-- if bag or bank changer is active then redraw is forced on - allows for when bags are changed as no events are triggered
	if ARKINV_BlizzardPlayerBagChanger:IsVisible() or ARKINV_BlizzardBankBagChanger:IsVisible() then
		ARKINV_G.LOCATION[loc_id].redraw = true
	end

	
	-- rescan all bags
	if not ARKINV_G.LOCATION[loc_id].offline then
		self:BagScanAll()
	end


	-- do we need to refresh or rebuild the window
	if not ARKINV_G.LOCATION[loc_id].rebuild and not ARKINV_G.LOCATION[loc_id].refresh then
		--self:Debug( { "ContainerGenerate( ", loc_id, " ) aborted, no need" } )
		return
	end
	
	
	-- if instant sort is on then redraw is forced on
	if self:OptionLocalGet( loc_id, { "sort", "instant" } ) or ARKINV_G.MODE.EDIT then
		ARKINV_G.LOCATION[loc_id].redraw = true
	end

	

	
	local obj

	getglobal( ARKINV_G.GUI_NAME .. loc_id ):SetScale( self:OptionLocalGet( loc_id, { "window", "scale" } ) )

	
	-- set the alpha level (transparency) and border colours for all child frames
	for _, z in pairs( { getglobal( ARKINV_G.GUI_NAME .. loc_id ):GetChildren() } ) do

		if self:OptionLocalGet( loc_id, { "window", "border" } ) then
			local colour = self:OptionLocalGet( loc_id, { "window", "colour", "border" } )
			z:SetBackdropBorderColor( colour.r, colour.g, colour.b, 1 )
		else
			z:SetBackdropBorderColor( 0, 0, 0, 0 )
		end

		obj = getglobal( z:GetName() .. "Background" )
		if obj then
			local colour = self:OptionLocalGet( loc_id, { "window", "colour", "background" } )
			obj:SetTexture( colour.r, colour.g, colour.b, colour.a )
		end
		
	end


	-- hide the header window if it's not needed
	obj = getglobal( frame:GetParent():GetName() .. "Title" )
	if self.db.account.option.framehide.header then
		obj:Hide()
		obj:SetHeight( 1 )
		
		obj = getglobal( frame:GetParent():GetName() .. "ContainerMenu" )
		obj:SetNormalTexture( ARKINV_G.LOCATION[loc_id].TEXTURE )
		obj:Show()
	else
		obj:SetHeight( 40 )
		obj:Show()
		getglobal( frame:GetParent():GetName() .. "ContainerMenu" ):Hide()
	end

	
	-- hide the status window if it's not needed
	obj = getglobal( frame:GetParent():GetName() .. "Status" )
	if self.db.account.option.framehide.status then
		obj:Hide()
		obj:SetHeight( 1 )
	else
		obj:SetHeight( 40 )
		obj:Show()
	end

	-- setup main icon
	getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleLocation0" ):SetNormalTexture( ARKINV_G.LOCATION[loc_id].TEXTURE )
	
	-- setup small icons
	for x in pairs( ARKINV_G.LOCATION ) do
		obj = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleLocation" .. x )
		obj:SetNormalTexture( ARKINV_G.LOCATION[x].TEXTURE )
		obj:SetPushedTexture( ARKINV_G.LOCATION[x].TEXTURE )
		obj:SetDisabledTexture( ARKINV_G.LOCATION[x].TEXTURE )
		obj:SetHighlightTexture( ARKINV_G.LOCATION[x].TEXTURE )
	end

	
	-- set the current player
	obj = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleWho" )
	t = { strmatch( current_player, "(.+) %- " ), strmatch( current_player, " %- (.+)" ) }
	
	tinsert( t, 2, ARKINV_G.LOCATION[loc_id].NAME )
	
	if ARKINV_G.LOCATION[loc_id].offline then
		obj:SetTextColor( 1, 0, 0 )
		tinsert( t, 3, ARKINV_L["STATUS_OFFLINE"] )
	else
		obj:SetTextColor( 0, 1, 0 )
	end
	
	if self.db.account.cache.who[current_player].faction then
		tinsert( t, self.db.account.cache.who[current_player].faction )
	end
	
	obj:SetText( table.concat( t, " - " ) )



	
	if ARKINV_G.LOCATION[loc_id].redraw and ARKINV_G.LOCATION[loc_id].rebuild then

		-- break the inventory up into it's respective bars
		self:CalculateBars( loc_id )

		-- calculate what the container should look like
		self:CalculateContainer( loc_id )


		local name
		
		-- create (if required) the bar frames, and hide any that are no longer required
		local barframename = frame:GetName() .. "Bar"
		local barframeobj = getglobal( barframename )
		if not barframeobj then
			-- error( "virtual bar holder frame [" .. barframename .. "] does not exist" )
			barframeobj = CreateFrame( "Frame", barframename, frame )
		end
		for j = 1, ARKINV_G.LOCATION[loc_id].bar_max do
			name = barframename .. j
			obj = getglobal( name )
			if not obj then
				-- error( "bar frame [" .. name .. "] does not exist" )
				obj = CreateFrame( "Frame", name, barframeobj, "ARKINV_TemplateFrameBar" )
			end
			obj:SetID( j )
			getglobal( name .. "Edit" ):Hide()
			
			obj:Hide()
		end

		-- calculate numer of active slots (required to keep track of the total number of slots a character has)
		self.db.account.cache.who[current_player].loc[loc_id].slot_count = self:tableSum( self.db.account.cache.who[current_player].loc[loc_id].bag, function( a ) return a.count end )

		-- create (if required) the virtual bags and their item buttons, and hide any that are not currently needed
		local bagframename = frame:GetName() .. "Bag"
		local bagframeobj = getglobal( bagframename )
		if not bagframeobj then
			-- error( "virtual bag holder frame [" .. bagframename .. "] does not exist" )
			bagframeobj = CreateFrame( "Frame", bagframename, frame )
		end
		
		for bagnum, bag in pairs( self.db.account.cache.who[current_player].loc[loc_id].bag ) do
		
			local bagname = bagframename .. bagnum
			local bagobj = getglobal( bagname )
			if not bagobj then
				--error( "bag frame [" .. bagname .. "] does not exist" )
				bagobj = CreateFrame( "Frame", bagname, bagframeobj )
				bagobj:SetWidth( 1 )
				bagobj:SetHeight( 1 )
				bagobj:SetPoint( "TOPLEFT", 0, 0 )
				bagobj:Show()
			end
			bagobj:SetID( bagnum )

			
			-- remember the maximum number of slots used for each bag
			if not ARKINV_G.LOCATION[loc_id].slot_max[bagnum] then
				ARKINV_G.LOCATION[loc_id].slot_max[bagnum] = self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].count
			else
			
				if self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].count > ARKINV_G.LOCATION[loc_id].slot_max[bagnum] then
					ARKINV_G.LOCATION[loc_id].slot_max[bagnum] = self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].count
				end
			
			end


			for j = 1, ARKINV_G.LOCATION[loc_id].slot_max[bagnum] do
				local itemname = self:ContainerItemNameGet( loc_id, bagnum, j )
				itemobj = getglobal( itemname )
				
				if not itemobj then
					-- error( "slot frame [" .. itemname .. " does not exist" )
					itemobj = CreateFrame( "Button", itemname, bagobj, "ARKINV_TemplateButtonItem" )
				end	
				itemobj:SetID( j )

				if j == 1 then
					ARKINV_G.BAG_SLOT_SIZE = itemobj:GetWidth()
				end
				
				if ARKINV_G.MODE.EDIT or ARKINV_G.LOCATION[loc_id].offline then
					-- disable clicks/drag when in edit mode or offline
					itemobj:RegisterForClicks()
					itemobj:RegisterForDrag()
				else
					itemobj:RegisterForClicks( "LeftButtonUp", "RightButtonUp" )
					itemobj:RegisterForDrag( "LeftButton" )
				end
	
				itemobj:Hide()
				
			end
			
		end
	

		-- build the bar frames
		local pad_slot = self:OptionLocalGet( loc_id, { "slot", "pad" } )
		local pad_bar_int = self:OptionLocalGet( loc_id, { "bar", "pad", "internal" } )
		local pad_bar_ext = self:OptionLocalGet( loc_id, { "bar", "pad", "external" } )
		local pad_window = self:OptionLocalGet( loc_id, { "window", "pad" } )
		local anchor = self:OptionLocalGet( loc_id, { "bar", "anchor" } )
		local direction = self:OptionLocalGet( loc_id, { "bar", "direction" } )
		local rmw = 0 -- row max width - each row is not the same width and we need to use the largest when sizing the main window

		self.db.account.cache.who[current_player].loc[loc_id].container.width = 0
		self.db.account.cache.who[current_player].loc[loc_id].container.height = pad_window * 2

		name = frame:GetName()
	
		for rownum, row in ipairs( self.db.account.cache.who[current_player].loc[loc_id].container.row ) do
	
			rmw = pad_window * 2
		
			for barnum, bar in ipairs( row.bar ) do

				obj = getglobal( name .. "Bar" .. bar.frame )

				obj:SetWidth( bar.width * ARKINV_G.BAG_SLOT_SIZE + ( bar.width - 1 ) * pad_slot + pad_bar_int * 2 )
				rmw = rmw + obj:GetWidth()
				if barnum > 1 then
					rmw = rmw + pad_bar_ext
				end
				
				obj:SetHeight( bar.height * ARKINV_G.BAG_SLOT_SIZE + ( bar.height - 1 ) * pad_slot + pad_bar_int * 2 )
				
				obj:ClearAllPoints()
				
				--self:Debug( "row=" .. rownum .. ", bar=" .. barnum .. ", obj=" .. obj:GetName() .. ", frame=" .. bar.frame )
				-- anchor first bar to frame
				if bar.frame == 1 then
				
					if anchor == ARKINV_G.ANCHOR.BOTTOMRIGHT then
						obj:SetPoint( "BOTTOMRIGHT", name, "BOTTOMRIGHT", 0 - pad_window, pad_window )
					elseif anchor == ARKINV_G.ANCHOR.BOTTOMLEFT then
						obj:SetPoint( "BOTTOMLEFT", name, "BOTTOMLEFT", pad_window, pad_window )
					elseif anchor == ARKINV_G.ANCHOR.TOPLEFT then
						obj:SetPoint( "TOPLEFT", name, "TOPLEFT", pad_window, 0 - pad_window )
					elseif anchor == ARKINV_G.ANCHOR.TOPRIGHT then
						obj:SetPoint( "TOPRIGHT", name, "TOPRIGHT", 0 - pad_window, 0 - pad_window )
					end
					
				else
				
					if barnum == 1 then
						-- next row, place under previous row
						--self:Debug( "anchor=" .. name .. "Bar" .. self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum-1].bar[1].frame )
						
						local pbar = name .. "Bar" .. self.db.account.cache.who[current_player].loc[loc_id].container.row[rownum-1].bar[1].frame
						
						if anchor == ARKINV_G.ANCHOR.BOTTOMRIGHT then
						
							if direction == ARKINV_G.DIRECTION.HORIZONTAL then
								obj:SetPoint( "BOTTOMRIGHT", pbar, "TOPRIGHT", 0, pad_bar_ext )
							elseif direction == ARKINV_G.DIRECTION.VERTICAL then
								obj:SetPoint( "BOTTOMRIGHT", pbar, "BOTTOMLEFT", 0 - pad_bar_ext, 0 )
							end
							
						elseif anchor == ARKINV_G.ANCHOR.BOTTOMLEFT then
						
							if direction == ARKINV_G.DIRECTION.HORIZONTAL then
								obj:SetPoint( "BOTTOMLEFT", pbar, "TOPLEFT", 0, pad_bar_ext )
							elseif direction == ARKINV_G.DIRECTION.VERTICAL then
								obj:SetPoint( "BOTTOMLEFT", pbar, "BOTTOMRIGHT", pad_bar_ext, 0 )
							end
							
						elseif anchor == ARKINV_G.ANCHOR.TOPLEFT then
						
							if direction == ARKINV_G.DIRECTION.HORIZONTAL then
								obj:SetPoint( "TOPLEFT", pbar, "BOTTOMLEFT", 0, 0 - pad_bar_ext )
							elseif direction == ARKINV_G.DIRECTION.VERTICAL then
								obj:SetPoint( "TOPLEFT", pbar, "TOPRIGHT", pad_bar_ext, 0 )
							end
							
						elseif anchor == ARKINV_G.ANCHOR.TOPRIGHT then
						
							if direction == ARKINV_G.DIRECTION.HORIZONTAL then
								obj:SetPoint( "TOPRIGHT", pbar, "BOTTOMRIGHT", 0, 0 - pad_bar_ext )
							elseif direction == ARKINV_G.DIRECTION.VERTICAL then
								obj:SetPoint( "TOPRIGHT", pbar, "TOPLEFT", 0 - pad_bar_ext, 0 )
							end
							
						end

					else
						-- next slot, place bar next to last one
						
						local pbar = name .. "Bar" .. ( bar.frame - 1 )
						
						if anchor == ARKINV_G.ANCHOR.BOTTOMRIGHT then
						
							if direction == ARKINV_G.DIRECTION.HORIZONTAL then
								obj:SetPoint( "BOTTOMRIGHT", pbar, "BOTTOMLEFT", 0 - pad_bar_ext, 0 )
							elseif direction == ARKINV_G.DIRECTION.VERTICAL then
								obj:SetPoint( "BOTTOMRIGHT", pbar, "TOPRIGHT", 0, pad_bar_ext )
							end
							
						elseif anchor == ARKINV_G.ANCHOR.BOTTOMLEFT then
						
							if direction == ARKINV_G.DIRECTION.HORIZONTAL then
								obj:SetPoint( "BOTTOMLEFT", pbar, "BOTTOMRIGHT", pad_bar_ext, 0 )
							elseif direction == ARKINV_G.DIRECTION.VERTICAL then
								obj:SetPoint( "BOTTOMLEFT", pbar, "TOPLEFT", 0, pad_bar_ext )
							end
							
						elseif anchor == ARKINV_G.ANCHOR.TOPLEFT then
						
							if direction == ARKINV_G.DIRECTION.HORIZONTAL then
								obj:SetPoint( "TOPLEFT", pbar, "TOPRIGHT", pad_bar_ext, 0 )
							elseif direction == ARKINV_G.DIRECTION.VERTICAL then
								obj:SetPoint( "TOPLEFT", pbar, "BOTTOMLEFT", 0, 0 - pad_bar_ext )
							end
							
						elseif anchor == ARKINV_G.ANCHOR.TOPRIGHT then
						
							if direction == ARKINV_G.DIRECTION.HORIZONTAL then
								obj:SetPoint( "TOPRIGHT", pbar, "TOPLEFT", 0 - pad_bar_ext, 0 )
							elseif direction == ARKINV_G.DIRECTION.VERTICAL then
								obj:SetPoint( "TOPRIGHT", pbar, "BOTTOMRIGHT", 0, 0 - pad_bar_ext )
							end
							
						end
						
					end
				
				end
				
			end

			if rmw > self.db.account.cache.who[current_player].loc[loc_id].container.width then
				self.db.account.cache.who[current_player].loc[loc_id].container.width = rmw
			end
		
			self.db.account.cache.who[current_player].loc[loc_id].container.height = self.db.account.cache.who[current_player].loc[loc_id].container.height + obj:GetHeight()

		end

		local x = ( self:tableElements( self.db.account.cache.who[current_player].loc[loc_id].container.row ) or 0 ) - 1
		self.db.account.cache.who[current_player].loc[loc_id].container.height = self.db.account.cache.who[current_player].loc[loc_id].container.height + pad_bar_ext * x

	end
		

	-- display bar borders if required
	self:GenerateBarBorder( frame:GetName() )
	
	
	-- display item icons
	for rownum, row in ipairs( self.db.account.cache.who[current_player].loc[loc_id].container.row ) do
		for barnum, bar in ipairs( row.bar ) do
			self:GenerateItems( loc_id, barnum, bar )
		end
	end

	
	if ARKINV_G.LOCATION[loc_id].redraw and ARKINV_G.LOCATION[loc_id].rebuild then	
	
		if self.db.account.cache.who[current_player].loc[loc_id].container.height < ARKINV_G.WINDOW_MIN_HEIGHT then
			self.db.account.cache.who[current_player].loc[loc_id].container.height = ARKINV_G.WINDOW_MIN_HEIGHT
		end
		
		if self.db.account.cache.who[current_player].loc[loc_id].container.width < ARKINV_G.WINDOW_MIN_WIDTH then
			self.db.account.cache.who[current_player].loc[loc_id].container.width = ARKINV_G.WINDOW_MIN_WIDTH
		end
		
		frame:SetHeight( self.db.account.cache.who[current_player].loc[loc_id].container.height )
		
		self:FrameUpdate( loc_id )
		
	end
	
	frame = getglobal( ARKINV_G.GUI_NAME .. loc_id )
	self:FramePosition( frame )
	
	-- if instant sort is on then reset the rebuild and refresh options otherwise leave them alone for next time
	if self:OptionLocalGet( loc_id, { "sort", "instant" } ) then
		ARKINV_G.LOCATION[loc_id].rebuild = false
		ARKINV_G.LOCATION[loc_id].refresh = false
	end
	
	ARKINV_G.LOCATION[loc_id].redraw = false
	
	
	--self:PrintPlus( { GREEN_FONT_COLOR_CODE, "ContainerGenerate( ", loc_id, " )" }, debuginfo )
	
end

function ARKINV:ContainerRestackFindPartial( loc_id, cb, cs, id )

	for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
	
		for slotnum = 1, GetContainerNumSlots( bagnum ) do

			if not ( bagnum == cb and slotnum == cs ) then
				
				iLink = GetContainerItemLink( bagnum, slotnum )
				if iLink then

					_, iCount = GetContainerItemInfo( bagnum, slotnum )
					iStack = select( 8, GetItemInfo( iLink ) )
					iID = strmatch( iLink, "item:(%-?%d+)" )
	
					if iID == id and iCount < iStack then
						--self:Print( "found match for partial stack at " .. bagnum .. "." .. slotnum )
						return true, bagnum, slotnum
					end
					
				end
				
			end
			
		end
		
	end

	-- self:Print( "no other partial stacks found" )
	return false

end

function ARKINV:ContainerRestackFindSpecial( loc_id, ct )

	for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
	
		local bt = self:BagType( bagnum )
		
		-- only match items in normal or unknown bags
		if ( bt == ARKINV_G.SLOT_BAG or bt == ARKINV_G.SLOT_UNKNOWN ) then
		
			for slotnum = 1, GetContainerNumSlots( bagnum ) do

				iLink = GetContainerItemLink( bagnum, slotnum )
				if iLink and ARKINV_SLOT_TABLE[ct].pt then

					if self:PT_ItemInSets( iLink, ARKINV_SLOT_TABLE[ct].pt ) then
						--self:Print( "found match for special slot at " .. bagnum .. "." .. slotnum )
						return true, bagnum, slotnum
					end
					
				end
				
			end
			
		end
		
	end

	-- self:Print( "no items found for special slot" )
	return false

end


function ARKINV:ContainerRestack( loc_id )

	-- DO NOT USE CACHED DATA FOR RESTACKING, PULL THE DATA DIRECTLY FROM WOW AGAIN

	-- self:Print( "ARKINV:ContainerRestack( " .. loc_id .. " )" )

	player = ARKINV_G.LOCATION[loc_id].player
	
	self:Print( ARKINV_L["MOD_MENU_MAIN_COMPRESS"] .. ": " .. ARKINV_L["STATUS_START"] )
	
	changed = true
	
	-- compress stacks
	while changed == true do
		
		changed = false
			
		for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
	
			for slotnum = 1, GetContainerNumSlots( bagnum ) do

				--self:Print( "checking bag " .. bagnum .. ", slot " .. slotnum )

				while true do

					_, iCount, locked = GetContainerItemInfo( bagnum, slotnum )
					
					if locked then
						--self:Print( "yielding - primary is locked" )
						coroutine.yield()
						--self:Print( "resumed" )
					else
						break
					end
			
				end

				iLink = GetContainerItemLink( bagnum, slotnum )

				if iLink then
					iStack = select( 8, GetItemInfo( iLink ) )
					iID = strmatch( iLink, "item:(%-?%d+)" )
	
					if iCount < iStack then
				
						--self:Print( "partial stack of item " .. iLink .. " found at " .. bagnum .. "." .. slotnum )
						local locked, ok, sb, ss
						
						while true do
					
							ok, sb, ss = self:ContainerRestackFindPartial( loc_id, bagnum, slotnum, iID )
							
							if ok then
								_, _, locked = GetContainerItemInfo( sb, ss )
							else
								locked = false
							end
						
							if locked then
								--self:Print( "yielding - secondary is locked" )
								coroutine.yield()
								--self:Print( "resumed" )
							else
								break
							end
							
						end
					
						if ok then
						
							--self:Print( "merging with other partial stack of item " .. iID .. " found at " .. sb .. "." .. ss )
							
							ClearCursor()
							PickupContainerItem( bagnum, slotnum )
							PickupContainerItem( sb, ss )
							ClearCursor()
							
							changed = true
						
						end
						
					end
				
				end
					
			end
				
		end
			
	end

	--self:Print( "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " - compress completed" )

	
	--self:Print( "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " - restack started" )
	
	-- move items into appropriate bag types with empty slots
	for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
	
		local bt = self:BagType( bagnum )
		-- self:Print( "bag " .. bagnum .. " = " .. ARKINV_SLOT_TABLE[bt].name )
			
		if not ( bt == ARKINV_G.SLOT_UNKNOWN or bt == ARKINV_G.SLOT_BAG or bt == ARKINV_G.SLOT_KEY ) then
	
			for slotnum = 1, GetContainerNumSlots( bagnum ) do

				-- self:Print( "checking bag " .. bagnum .. " (" .. ARKINV_SLOT_TABLE[bt].name .. "), slot " .. slotnum )

				while true do

					_, _, locked = GetContainerItemInfo( bagnum, slotnum )
					
					if locked then
						-- self:Print( "yielding - primary is locked" )
						coroutine.yield()
						-- self:Print( "resumed" )
					else
						break
					end
		
				end

				if not GetContainerItemLink( bagnum, slotnum ) then
					
					local locked, ok, sb, ss
					-- self:Print( "empty special slot found at " .. bagnum .. "." .. slotnum )
				
					while true do
				
						ok, sb, ss = self:ContainerRestackFindSpecial( loc_id, bt )
							
						if ok then
							_, _, locked = GetContainerItemInfo( sb, ss )
						else
							locked = false
						end
						
						if locked then
							-- self:Print( "yielding - secondary is locked" )
							coroutine.yield()
							-- self:Print( "resumed" )
						else
							break
						end
						
					end
					
					if ok then
						
						-- self:Print( "moving " .. iLink .. " from " .. sb .. "." .. ss .. " to special slot " .. bagnum .. "." .. slotnum )
						
						ClearCursor()
						PickupContainerItem( sb, ss )
						PickupContainerItem( bagnum, slotnum )
						ClearCursor()

					end
					
				end
			
			end
				
		end
			
	end

	self:Print( ARKINV_L["MOD_MENU_MAIN_COMPRESS"] .. ": " .. ARKINV_L["STATUS_FINISH"] )

end

function ARKINV:ContainerRestackStart( loc_id )

	if ARKINV_G.LOCATION[loc_id].offline then

		message( "Cannot restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " in offline mode" )
		
	else
	
		if type( ARKINV_G.COROUTINE.RESTACK ) ~= "thread" or coroutine.status( ARKINV_G.COROUTINE.RESTACK ) == "dead" then
	
			-- thread not active, create a new one
			-- self:Print( "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " started" )
			ARKINV_G.COROUTINE.RESTACK = coroutine.create(
				function ()
					self:ContainerRestack( loc_id )
				end
			)
			coroutine.resume( ARKINV_G.COROUTINE.RESTACK )
			
		else
	
			-- restack already in progress
			self:Print( RED_FONT_COLOR_CODE .. "Restack " .. ARKINV_G.LOCATION[loc_id].NAME .. " is already in progress please wait for completion" )
		
		end
		
	end

end

function ARKINV:ContainerRestackResume()

	-- self:Print( "ARKINV:ContainerRestackResume()" )
	
	if type( ARKINV_G.COROUTINE.RESTACK ) == "thread" and coroutine.status( ARKINV_G.COROUTINE.RESTACK ) == "suspended" then

		-- resume current thread
		coroutine.resume( ARKINV_G.COROUTINE.RESTACK )
		
	end
	
end

function ARKINV:ItemButton_Details( widget )

	if not widget then
		widget = this
	end
	
	if type( widget ) ~= "string" then
		widget = widget:GetName()
	end

	local loc_id = strmatch( widget, "^" .. ARKINV_G.GUI_NAME .. "(%d+)" )

	local bagnum = nil
	local slotnum = nil
	local player = nil
	local i = nil

	if loc_id then
	
		bagnum, slotnum = strmatch( widget, "^" .. ARKINV_G.GUI_NAME .. "%d+ContainerBag(%-?%d+)Slot(%d+)" )
	
		loc_id = tonumber( loc_id )
		bagnum = tonumber( bagnum )
		slotnum = tonumber( slotnum )
		
		player = ARKINV_G.LOCATION[loc_id].player
		
		if bagnum and slotnum then
			i = self.db.account.cache.who[player].loc[loc_id].bag[bagnum].slot[slotnum]
		end
	end

	return loc_id, bagnum, slotnum, player, i
	
end


function ARKINV:ItemButton_OnClick( arg1 )

	if ( not IsModifierKeyDown() or IsShiftKeyDown() or IsAutoLootKeyDown() ) then

		local obj = this
	
		local usedmycode = false
		
		local loc_id = self:ItemButton_Details()
	
		if ( loc_id and ARKINV_G.LOCATION[loc_id].offline ) or ARKINV_G.MODE.EDIT then
		
			usedmycode = true
			-- do nothing for disabled buttons
			
		end

		if usedmycode == false then
			ContainerFrameItemButton_OnClick( arg1 )
		end

	end

end

function ARKINV:ItemButton_OnEnter()

	local obj = this
	
	-- self:Print( "ARKINV:ItemButton_OnEnter( " .. obj:GetName() .. " )" )
	
	local usedmycode = false

	loc_id, bagnum, slotnum, player, i = self:ItemButton_Details()
	
	if loc_id and ( ARKINV_G.LOCATION[loc_id].offline or bagnum == -1 or bagnum == -2 or ARKINV_G.MODE.EDIT ) then

		-- offline, bank, keyring or edit mode
		usedmycode = true
		
		if i.h then
		
			-- position tooltip to the left or right depending on location
			local x
			x = obj:GetRight()
			if ( x >= ( GetScreenWidth() / 2 ) ) then
				GameTooltip:SetOwner( obj, "ANCHOR_LEFT" )
			else
				GameTooltip:SetOwner( obj, "ANCHOR_RIGHT" )
			end

			if ARKINV_G.LOCATION[loc_id].offline then
				-- offline, build tooltip from itemlink
				GameTooltip:SetHyperlink( i.h )
			elseif bagnum == BANK_CONTAINER then
				GameTooltip:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) )
			elseif bagnum == KEYRING_CONTAINER then
				GameTooltip:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) )
			elseif ARKINV_G.MODE.EDIT then
				GameTooltip:SetBagItem( bagnum, slotnum )
			end
			
			GameTooltip:Show()
			
		end

	end
	
	if usedmycode == false then
		ContainerFrameItemButton_OnEnter()
	end

end

function ARKINV:ItemButton_Drag()

	local obj = this

	local usedmycode = false
	
	loc_id, bagnum, slotnum, player, i = self:ItemButton_Details()

	if ( loc_id and ARKINV_G.LOCATION[loc_id].offline ) or ARKINV_G.MODE.EDIT then
	
		usedmycode = true
		-- do not drag for disabled buttons
		
	end

	if usedmycode == false then
		ContainerFrameItemButton_OnClick( "LeftButton" )
	end

end

function ARKINV:ItemButton_OnEvent()

	if GameTooltip:IsOwned( this ) then
		self:ItemButton_OnEnter()
	end

end

function ARKINV:ItemButton_OnUpdate( elapsed )
	
	if ( this.updateTooltip ) then
		this.updateTooltip = this.updateTooltip - elapsed
		if ( this.updateTooltip > 0 ) then
			return
		end
	end

	self:ItemButton_OnEvent()
	
end

function ARKINV:ItemButton_OnMouseUp( button )

	loc_id, _, _, _, i = self:ItemButton_Details()
	if ( loc_id and ARKINV_G.LOCATION[loc_id].offline ) or ARKINV_G.MODE.EDIT then
	
		if IsModifierKeyDown() then
		
			if i.h then
			
				if button == "LeftButton" then
				
					if IsControlKeyDown() then
						DressUpItemLink( i.h )
					elseif IsShiftKeyDown() then
						ChatEdit_InsertLink( i.h )
					end
					
				end
					
			end
			
		else

			if ARKINV_G.MODE.EDIT then
				self:MenuItemOpen()
			end

		end
		
	end
	
end


function ARKINV:BagHighlight( show )

	local bagnum = this:GetID()

	if strmatch( this:GetName(), ".+Slot" ) then
		loc_id = ARKINV_G.LOCATION_BAG
		bagnum = bagnum - CharacterBag0Slot:GetID() + 1
	else
		loc_id = ARKINV_G.LOCATION_BANK
	end
	
	if loc_id and bagnum then
	
		bagnum = tonumber( bagnum )
	
		local current_player = ARKINV_G.LOCATION[loc_id].player
		
		local name = ARKINV_G.GUI_NAME .. loc_id .. "ContainerBag" .. bagnum
		local frame = getglobal( name )
		if not frame then return end

		local colour = self:OptionLocalGet( loc_id, { "window", "colour", "baghighlight" } )

		for slotnum in pairs( self.db.account.cache.who[current_player].loc[loc_id].bag[bagnum].slot ) do
			obj = getglobal( name .. "Slot" .. slotnum .. "ArkHighlight" )
			if obj then
				if show then
					getglobal( obj:GetName() .. "Background" ):SetTexture( colour.r, colour.g, colour.b, 0.3 )
					obj:Show()
				else
					obj:Hide()
				end
			end
			
		end
	
	end
	
end



function ARKINV:MenuMainOpen()

	if dd:IsOpen( this ) then
	
		dd:Close()
	
	else

		local loc_id, _, _, current_player = self:ItemButton_Details()
	
		local base_options = { type = "group", args = {} }
		dd:InjectAceOptionsTable( self, base_options )

		
	
		local x, pos
		x = this:GetRight()
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			pos = "TOPRIGHT"
		else
			pos = "TOPLEFT"
		end
	
		dd:Open( this,
			"point", pos,
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
			
					local t = format( "%1$s v%2$.2f", ARKINV_G.PROGRAM_NAME, ARKINV_G.PROGRAM_VERSION )
					dd:AddLine( "text", t, "isTitle", true, "textHeight", 14 )
					
					if ARKINV_G.PROGRAM_BETA then
						t = RED_FONT_COLOR_CODE .. "(beta " .. ARKINV_G.PROGRAM_BETA .. ")"
						dd:AddLine( "text", t, "nonClickable", true )
					end

					dd:AddLine()
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER"],
						"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER"],
						"tooltipText", ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER_TEXT"],
						"hasArrow", true,
						"value", "SWITCH_CHARACTER"
					)
					
					dd:AddLine()
					
					dd:AddLine(	"text", ARKINV_L["MOD_MENU_MAIN_GLOBAL_SETTINGS"],
						"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_GLOBAL_SETTINGS"],
						"tooltipText", ARKINV_L["MOD_MENU_MAIN_GLOBAL_SETTINGS_TEXT"],
						"checked", self.db.profile.option.useglobal,
						"func", function()
							self.db.profile.option.useglobal = not self.db.profile.option.useglobal
							dd:Close()
							self:ContainerGenerateRedrawAll()
						end
					)

					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW"],
						"hasArrow", true,
						"value", "WINDOW"
					)
	
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS"],
						"hasArrow", true,
						"value", "BAR"
					)
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_ITEMS"],
						"hasArrow", true,
						"value", "ITEM"
					)
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_SORTING"],
						"hasArrow", true,
						"value", "SORT"
					)
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_EMPTY"],
						"hasArrow", true,
						"value", "EMPTY"
					)
					
					
					dd:AddLine()
				
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_OFFLINE"],
						"hasArrow", true,
						"value", "OFFLINE"
					)

					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_HIDDEN"],
						"hasArrow", true,
						"value", "HIDDEN"
					)
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO"],
						"hasArrow", true,
						"value", "AUTO"
					)
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_NEWITEM"],
						"hasArrow", true,
						"value", "NEWITEM"
					)
					
					
					dd:AddLine()
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_REFRESH"],
						"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_REFRESH"],
						"tooltipText", ARKINV_L["MOD_MENU_MAIN_REFRESH_TEXT"],
						"func", function()
							self:ContainerGenerateRedrawAll()
							dd:Close()
						end
					)
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_RELOAD"],
						"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_RELOAD"],
						"tooltipText", ARKINV_L["MOD_MENU_MAIN_RELOAD_TEXT"],
						"func", function()
							self:ClearItemCache()
							self:ContainerGenerateRedrawAll()
							dd:Close()
						end
					)
					
					dd:AddLine(	"text", ARKINV_L["MOD_MENU_MAIN_EDITMODE"],
						"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_EDITMODE"],
						"tooltipText", ARKINV_L["MOD_MENU_MAIN_EDITMODE_TEXT"],
						"checked", ARKINV_G.MODE.EDIT,
						"func", function()
							dd:Close()
							self:ToggleEditMode()
						end
					)

					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BAGCHANGE"],
						"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BAGCHANGE"],
						"tooltipText", ARKINV_L["MOD_MENU_MAIN_BAGCHANGE_TEXT"],
						"func", function()
							dd:Close()
							self:ToggleBagChanger()
						end
					)

					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_COMPRESS"],
						"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_COMPRESS"],
						"tooltipText", ARKINV_L["MOD_MENU_MAIN_COMPRESS_TEXT"],
						"func", function()
							dd:Close()
							self:ContainerRestackStart( loc_id )
						end
					)

					dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_RULES"],
						"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_RULES"],
						"tooltipText", ARKINV_L["MOD_MENU_MAIN_RULES_TEXT"],
						"func", function()
							ARKINV_Rules:Show()
							dd:Close()
						end
					)

					dd:AddLine()
					-- leaves space on the end for the base options
					
				end


				if level == 2 and value then
				
					if value == "SWITCH_CHARACTER" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER"] ), "isTitle", true, "textHeight", 12 )

						dd:AddLine()

						if self:tableElements( self.db.account.cache.who ) == 1 then

							dd:AddLine(	"text", ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER_CHOOSE_NONE"],
								"nonClickable", true
							)
		
						else
							
							for k, v in self:spairs( self.db.account.cache.who, function(a,b) return self.db.account.cache.who[a].name < self.db.account.cache.who[b].name end ) do
						
								local n = v.name
								if k == ARKINV_G.ME then
									n = GREEN_FONT_COLOR_CODE .. v.name .. FONT_COLOR_CODE_CLOSE
								end

								if k ~= current_player then
									dd:AddLine(	"text", n,
										"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER"],
										"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER_CHOOSE_TEXT"], k ),
										"hasArrow", k ~= ARKINV_G.ME,
										"func", function()
											dd:Close()
											self:ContainerOpen( loc_id, k )
										end,
										"value", ( "SWITCH_CHARACTER_" .. k )
									)
								end
							end
					
						end
						
					end
				
					if value == "WINDOW" then
					
						local n = string.upper( ARKINV_L["MOD_MENU_MAIN_WINDOW"] )
						if not self.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ARKINV_G.LOCATION[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()



--[[
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW_ANCHOR"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_WINDOW_ANCHOR_TEXT"],
							"hasArrow", true,
							"value", "WINDOW_ANCHOR"
						)
]]--
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW_SCALE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_WINDOW_SCALE"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_WINDOW_SCALE_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderIsPercent", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "window", "scale" } ),
							"sliderMin", 0.4,
							"sliderMax", 2,
							"sliderStep", 0.05,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "window", "scale" } ) then
									self:OptionLocalSet( loc_id, { "window", "scale" }, v )
									self:ContainerGenerateRefreshAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW_PADDING"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_WINDOW_PADDING"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_WINDOW_PADDING_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "window", "pad" } ),
							"sliderMin", 4,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "window", "pad" } ) then
									self:OptionLocalSet( loc_id, { "window", "pad" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW_WIDTH"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_WINDOW_WIDTH"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_WINDOW_WIDTH_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "window", "width" } ),
							"sliderMin", 8,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "window", "width" } ) then
									self:OptionLocalSet( loc_id, { "window", "width" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW_BACKGROUND_COLOR"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_WINDOW_BACKGROUND_COLOR"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_WINDOW_BACKGROUND_COLOR_TEXT"],
							"hasColorSwatch", true,
							"hasOpacity", true,
							"r", self:OptionLocalGet( loc_id, { "window", "colour", "background", "r" } ),
							"g", self:OptionLocalGet( loc_id, { "window", "colour", "background", "g" } ),
							"b", self:OptionLocalGet( loc_id, { "window", "colour", "background", "b" } ),
							"opacity", self:OptionLocalGet( loc_id, { "window", "colour", "background", "a" } ),
							"colorFunc", function( r, g, b, a )
								self:OptionLocalSet( loc_id, { "window", "colour", "background", "r" }, r )
								self:OptionLocalSet( loc_id, { "window", "colour", "background", "g" }, g )
								self:OptionLocalSet( loc_id, { "window", "colour", "background", "b" }, b )
								self:OptionLocalSet( loc_id, { "window", "colour", "background", "a" }, a )
								self:ContainerGenerateRefreshAll()
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW_BORDER"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_WINDOW_BORDER"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_WINDOW_BORDER_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "window", "border" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "window", "border" }, not self:OptionLocalGet( loc_id, { "window", "border" } ) )
								self:ContainerGenerateRefreshAll()
							end
						)
						if self:OptionLocalGet( loc_id, { "window", "border" } ) then
							dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW_BORDER_COLOR"],
								"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_WINDOW_BORDER_COLOR"],
								"tooltipText", ARKINV_L["MOD_MENU_MAIN_WINDOW_BORDER_COLOR_TEXT"],
								"hasColorSwatch", true,
								"r", self:OptionLocalGet( loc_id, { "window", "colour", "border", "r" } ),
								"g", self:OptionLocalGet( loc_id, { "window", "colour", "border", "g" } ),
								"b", self:OptionLocalGet( loc_id, { "window", "colour", "border", "b" } ),
								"colorFunc", function( r, g, b )
									self:OptionLocalSet( loc_id, { "window", "colour", "border", "r" }, r )
									self:OptionLocalSet( loc_id, { "window", "colour", "border", "g" }, g )
									self:OptionLocalSet( loc_id, { "window", "colour", "border", "b" }, b )
									self:ContainerGenerateRefreshAll()
								end
							)
						end
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_WINDOW_BAGHIGHLIGHT_COLOR"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_WINDOW_BAGHIGHLIGHT_COLOR"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_WINDOW_BAGHIGHLIGHT_COLOR_TEXT"],
							"hasColorSwatch", true,
							"hasOpacity", false,
							"r", self:OptionLocalGet( loc_id, { "window", "colour", "baghighlight", "r" } ),
							"g", self:OptionLocalGet( loc_id, { "window", "colour", "baghighlight", "g" } ),
							"b", self:OptionLocalGet( loc_id, { "window", "colour", "baghighlight", "b" } ),
							"colorFunc", function( r, g, b )
								self:OptionLocalSet( loc_id, { "window", "colour", "baghighlight", "r" }, r )
								self:OptionLocalSet( loc_id, { "window", "colour", "baghighlight", "g" }, g )
								self:OptionLocalSet( loc_id, { "window", "colour", "baghighlight", "b" }, b )
							end
						)
					
					end
					
					if value == "BAR" then
						
						local n = string.upper( ARKINV_L["MOD_MENU_MAIN_BARS"] )
						if not self.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ARKINV_G.LOCATION[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_ANCHOR"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_ANCHOR"],
							"hasArrow", true,
							"value", "BAR_ANCHOR"
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_DIRECTION"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_DIRECTION"],
							"hasArrow", true,
							"value", "BAR_DIRECTION"
						)
						dd:AddLine(	"text", ARKINV_L["MOD_MENU_MAIN_BARS_PER_ROW"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_PER_ROW"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_PER_ROW_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "bar", "per" } ),
							"sliderMin", 1,
							"sliderMax", 16,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "bar", "per" } ) then
									self:OptionLocalSet( loc_id, { "bar", "per" }, v )
									self:ContainerGenerateRefreshAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_PADDING"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_PADDING"],
							"hasArrow", true,
							"value", "BAR_PADDING"
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_COMPACT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_COMPACT"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_COMPACT_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "bar", "compact" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "bar", "compact" }, not self:OptionLocalGet( loc_id, { "bar", "compact" } ) )
								self:ContainerGenerateRedrawAll()
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_SHOW_EMPTY"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_SHOW_EMPTY"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_SHOW_EMPTY_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "bar", "showempty" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "bar", "showempty" }, not self:OptionLocalGet( loc_id, { "bar", "showempty" } ) )
								self:ContainerGenerateRedrawAll()
							end
						)

						dd:AddLine()

						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_HIDE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_HIDE"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_HIDE_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "bar", "hide" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "bar", "hide" }, not self:OptionLocalGet( loc_id, { "bar", "hide" } ) )
								self:ContainerGenerateRedrawAll()
							end
						)
						
						if not self:OptionLocalGet( loc_id, { "bar", "hide" } ) then
						
							dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_BACKGROUND"],
								"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_BACKGROUND"],
								"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_BACKGROUND_TEXT"],
								"hasColorSwatch", true,
								"hasOpacity", true,
								"r", self:OptionLocalGet( loc_id, { "bar", "colour", "background", "r" } ),
								"g", self:OptionLocalGet( loc_id, { "bar", "colour", "background", "g" } ),
								"b", self:OptionLocalGet( loc_id, { "bar", "colour", "background", "b" } ),
								"opacity", self:OptionLocalGet( loc_id, { "bar", "colour", "background", "a" } ),
								"colorFunc", function( r, g, b, a )
									self:OptionLocalSet( loc_id, { "bar", "colour", "background", "r" }, r )
									self:OptionLocalSet( loc_id, { "bar", "colour", "background", "g" }, g )
									self:OptionLocalSet( loc_id, { "bar", "colour", "background", "b" }, b )
									self:OptionLocalSet( loc_id, { "bar", "colour", "background", "a" }, a )
									self:ContainerGenerateRefreshAll()
								end
							)
							
							dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_BORDER"],
								"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_BORDER"],
								"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_BORDER_TEXT"],
								"checked", self:OptionLocalGet( loc_id, { "bar", "border" } ),
								"func", function()
									self:OptionLocalSet( loc_id, { "bar", "border" }, not self:OptionLocalGet( loc_id, { "bar", "border" } ) )
									self:ContainerGenerateRefreshAll()
								end
							)
							if self:OptionLocalGet( loc_id, { "bar", "border" } ) then
								dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_BARS_BORDER_COLOUR"],
									"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_BARS_BORDER_COLOUR"],
									"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_BORDER_COLOUR_TEXT"],
									"hasColorSwatch", true,
									"r", self:OptionLocalGet( loc_id, { "bar", "colour", "border", "r" } ),
									"g", self:OptionLocalGet( loc_id, { "bar", "colour", "border", "g" } ),
									"b", self:OptionLocalGet( loc_id, { "bar", "colour", "border", "b" } ),
									"colorFunc", function( r, g, b )
										self:OptionLocalSet( loc_id, { "bar", "colour", "border", "r" }, r )
										self:OptionLocalSet( loc_id, { "bar", "colour", "border", "g" }, g )
										self:OptionLocalSet( loc_id, { "bar", "colour", "border", "b" }, b )
										self:ContainerGenerateRefreshAll()
									end
								)
							end
							
						end
						
					end
					
					if value == "ITEM" then
					
						local n = string.upper( ARKINV_L["MOD_MENU_MAIN_ITEMS"] )
						if not self.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ARKINV_G.LOCATION[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_ITEMS_PADDING"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_ITEMS_PADDING"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_ITEMS_PADDING_TEXT"],
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "slot", "pad" } ),
							"sliderMin", 1,
							"sliderMax", 16,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if self:OptionLocalGet( loc_id, { "slot", "pad" } ) ~= v then
									self:OptionLocalSet( loc_id, { "slot", "pad" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_ITEMS_BORDER"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_ITEMS_BORDER"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_ITEMS_BORDER_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "slot", "border" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "border" }, not self:OptionLocalGet( loc_id, { "slot", "border" } ) )
								self:ContainerGenerateRefreshAll()
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_ITEMS_HIDDEN"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_ITEMS_HIDDEN"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_ITEMS_HIDDEN_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "slot", "ignorehidden" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "ignorehidden" }, not self:OptionLocalGet( loc_id, { "slot", "ignorehidden" } ) )
								self:ContainerGenerateRedrawAll()
							end
						)
		
					end
					
					if value == "SORT" then

						local n = string.upper( ARKINV_L["MOD_MENU_MAIN_SORTING"] )
						if not self.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ARKINV_G.LOCATION[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()

						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_SORTING_BAGSLOT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SORTING_BAGSLOT"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_SORTING_BAGSLOT_TEXT"],
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "sort", "type" } ) == ARKINV_G.SLOT_SORT_BAGSLOT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "sort", "type" } ) ~= ARKINV_G.SLOT_SORT_BAGSLOT then
									self:OptionLocalSet( loc_id, { "sort", "type" }, ARKINV_G.SLOT_SORT_BAGSLOT )
									self:ItemSortKeyRegenerate( loc_id )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_SORTING_NAME"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SORTING_NAME"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_SORTING_NAME_TEXT"],
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "sort", "type" } ) == ARKINV_G.SLOT_SORT_NAME,
							"func", function()
								if self:OptionLocalGet( loc_id, { "sort", "type" } ) ~= ARKINV_G.SLOT_SORT_NAME then
									self:OptionLocalSet( loc_id, { "sort", "type" }, ARKINV_G.SLOT_SORT_NAME )
									self:ItemSortKeyRegenerate( loc_id )
									self:ContainerGenerateRedrawAll()
								end
							end
						)

						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_REVERSE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_REVERSE"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_REVERSE_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "sort", "reversed" } ),
							"disabled", self:OptionLocalGet( loc_id, { "sort", "type" } ) ~= ARKINV_G.SLOT_SORT_NAME,
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "reversed" }, not self:OptionLocalGet( loc_id, { "sort", "reversed" } ) )
								self:ItemSortKeyRegenerate( loc_id )
								self:ContainerGenerateRedrawAll()
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_QUALITY"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_QUALITY"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_QUALITY_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "sort", "quality" } ),
							"disabled", self:OptionLocalGet( loc_id, { "sort", "type" } ) ~= ARKINV_G.SLOT_SORT_NAME,
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "quality" }, not self:OptionLocalGet( loc_id, { "sort", "quality" } ) )
								self:ItemSortKeyRegenerate( loc_id )
								self:ContainerGenerateRedrawAll()
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_LOCATION"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_LOCATION"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_LOCATION_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "sort", "location" } ),
							"disabled", self:OptionLocalGet( loc_id, { "sort", "type" } ) ~= ARKINV_G.SLOT_SORT_NAME,
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "location" }, not self:OptionLocalGet( loc_id, { "sort", "location" } ) )
								self:ItemSortKeyRegenerate( loc_id )
								self:ContainerGenerateRedrawAll()
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_CATEGORY"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_CATEGORY"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_SORTING_INCLUDE_CATEGORY_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "sort", "category" } ),
							"disabled", self:OptionLocalGet( loc_id, { "sort", "type" } ) ~= ARKINV_G.SLOT_SORT_NAME,
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "category" }, not self:OptionLocalGet( loc_id, { "sort", "category" } ) )
								self:ItemSortKeyRegenerate( loc_id )
								self:ContainerGenerateRedrawAll()
							end
						)
							
						dd:AddLine()
						
						dd:AddLine(	"text", ARKINV_L["MOD_MENU_MAIN_SORTING_INSTANT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SORTING_INSTANT"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_SORTING_INSTANT_TEXT"],
							"disabled", not self.db.account.option.framehide.changer,
							"checked", self:OptionLocalGet( loc_id, { "sort", "instant" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "sort", "instant" }, not self:OptionLocalGet( loc_id, { "sort", "instant" } ) )
								self:ItemSortKeyRegenerate( loc_id )
								self:ContainerGenerateRebuildAll()
							end
						)
						
					end
					
					if value == "EMPTY" then

						local n = string.upper( ARKINV_L["MOD_MENU_MAIN_EMPTY"] )
						if not self.db.profile.option.useglobal then
							n = n .. " [" .. GREEN_FONT_COLOR_CODE .. string.upper( ARKINV_G.LOCATION[loc_id].NAME ) .. FONT_COLOR_CODE_CLOSE .. "]"
						end
						dd:AddLine( "text", n, "isTitle", true, "textHeight", 12 )

						dd:AddLine()

						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_EMPTY_ICON"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_EMPTY_ICON"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_EMPTY_ICON_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) == true,
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "empty", "icon" }, not self:OptionLocalGet( loc_id, { "slot", "empty", "icon" } ) )
								self:ContainerGenerateRedrawAll()
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_EMPTY_BORDER"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_EMPTY_BORDER"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_EMPTY_BORDER_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "slot", "empty", "border" } ) == true,
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "empty", "border" }, not self:OptionLocalGet( loc_id, { "slot", "empty", "border" } ) )
								self:ContainerGenerateRedrawAll()
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_EMPTY_COLOUR"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_EMPTY_COLOUR"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_EMPTY_COLOUR_TEXT"],
							"hasArrow", true,
							"value", "EMPTY_COLOUR"
						)
						dd:AddLine()
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_EMPTY_CLUMP"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_EMPTY_CLUMP"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_EMPTY_CLUMP_TEXT"],
							"checked", self:OptionLocalGet( loc_id, { "slot", "empty", "clump" } ),
							"func", function()
								self:OptionLocalSet( loc_id, { "slot", "empty", "clump" }, not self:OptionLocalGet( loc_id, { "slot", "empty", "clump" } ) )
								self:ItemCategoryReloadEmpty()
								self:ContainerGenerateRedrawAll()
							end
						)
					
					end
					
					
					if value == "OFFLINE" then

						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_OFFLINE"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_OFFLINE_BAG"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_OFFLINE_BAG"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_OFFLINE_BAG_TEXT"],
							"checked", self.db.account.option.offline.alt,
							"func", function()
								self.db.account.option.offline.alt = not self.db.account.option.offline.alt
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_OFFLINE_BANK"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_OFFLINE_BANK"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_OFFLINE_BANK_TEXT"],
							"checked", self.db.account.option.offline.bank,
							"func", function()
								self.db.account.option.offline.bank = not self.db.account.option.offline.bank
							end
						)
						dd:AddLine()
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_ITEMS_FADE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_ITEMS_FADE"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_ITEMS_FADE_TEXT"],
							"checked", self.db.account.option.offline.fade,
							"func", function()
								self.db.account.option.offline.fade = not self.db.account.option.offline.fade
								self:ContainerGenerateRefreshAll()
							end
						)
					
					end
					
					if value == "HIDDEN" then

						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_HIDDEN"] ), "isTitle", true, "textHeight", 12 )
						
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_HIDDEN_TITLE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_HIDDEN_TITLE"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_HIDDEN_TITLE_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.framehide.header,
							"func", function()
								dd:Close()
								self.db.account.option.framehide.header = not self.db.account.option.framehide.header
								self:ContainerGenerateRefreshAll()
							end
						)
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_HIDDEN_STATUS"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_HIDDEN_STATUS"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_HIDDEN_STATUS_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.framehide.status,
							"func", function()
								self.db.account.option.framehide.status = not self.db.account.option.framehide.status
								self:ContainerGenerateRefreshAll()
							end
						)
						
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_HIDDEN_BLIZZARD"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_HIDDEN_BLIZZARD"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_HIDDEN_BLIZZARD_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.framehide.blizzard,
							"func", function()
								self.db.account.option.framehide.blizzard = not self.db.account.option.framehide.blizzard
								self:HookBlizzardAPI()
							end
						)

						
					end
					
					if value == "AUTO" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_AUTO"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
					
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_OPEN"],
							"hasArrow", true,
							"value", "AUTO_OPEN"
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_CLOSE"],
							"hasArrow", true,
							"value", "AUTO_CLOSE"
						)

					end
					
					if value == "NEWITEM" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_NEWITEM"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_NEWITEM_SHOW"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_NEWITEM_SHOW"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_NEWITEM_SHOW_TEXT"],
							"checked", self.db.account.option.newitem.show,
							"func", function()
								self.db.account.option.newitem.show = not self.db.account.option.newitem.show
								self:ContainerGenerateRefreshAll()
							end
						)
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_NEWITEM_COLOUR"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_NEWITEM_COLOUR"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_NEWITEM_COLOUR_TEXT"],
							"hasColorSwatch", true,
							"r", self.db.account.option.newitem.colour.r,
							"g", self.db.account.option.newitem.colour.g,
							"b", self.db.account.option.newitem.colour.b,
							"colorFunc", function( r, g, b )
								self.db.account.option.newitem.colour.r = r
								self.db.account.option.newitem.colour.g = g
								self.db.account.option.newitem.colour.b = b
								self:ContainerGenerateRefreshAll()
							end
						)
						
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_NEWITEM_RESET"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_NEWITEM_RESET"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_NEWITEM_RESET_TEXT"],
							"func", function()
								dd:Close()
								self:NewItemReset( loc_id )
								self:ContainerGenerateRefreshAll()
							end
						)
						
					end
					
				end


				if level == 3 and value then
				
					if strsub( value, 1, 17 ) == "SWITCH_CHARACTER_" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						local k = strmatch( value, "SWITCH_CHARACTER_(.+)" )
						
						dd:AddLine(	"text", RED_FONT_COLOR_CODE .. ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER_ERASE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER_ERASE"],
							"tooltipText", RED_FONT_COLOR_CODE .. format( ARKINV_L["MOD_MENU_MAIN_SWITCH_CHARACTER_ERASE_TEXT"], k ),
							"func", function()
								dd:Close()
								self.db.account.cache.who[k] = nil
								ARKINV_G.LOCATION[loc_id].player = ARKINV_G.ME
								self:ContainerCloseAll()
								self:ContainerGenerateRebuild( loc_id )
							end
						)	
						
					end
				
					if value == "WINDOW_ANCHOR" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_WINDOW_ANCHOR"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						dd:AddLine( "text", "BOTTOMRIGHT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the bottom right",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "window", "anchor" } ) == ARKINV_G.ANCHOR.BOTTOMRIGHT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "window", "anchor" } ) ~= ARKINV_G.ANCHOR.BOTTOMRIGHT then
									self:AnchorSet( loc_id, ARKINV_G.ANCHOR.BOTTOMRIGHT )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "BOTTOMLEFT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the bottom left",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "window", "anchor" } ) == ARKINV_G.ANCHOR.BOTTOMLEFT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "window", "anchor" } ) ~= ARKINV_G.ANCHOR.BOTTOMLEFT then
									self:AnchorSet( loc_id, ARKINV_G.ANCHOR.BOTTOMLEFT )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "TOPLEFT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the top left",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "window", "anchor" } ) == ARKINV_G.ANCHOR.TOPLEFT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "window", "anchor" } ) ~= ARKINV_G.ANCHOR.TOPLEFT then
									self:AnchorSet( loc_id, ARKINV_G.ANCHOR.TOPLEFT )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "TOPRIGHT",
							"tooltipTitle", "Window anchor point",
							"tooltipText", "anchors the window in the top right",
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "window", "anchor" } ) == ARKINV_G.ANCHOR.TOPRIGHT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "window", "anchor" } ) ~= ARKINV_G.ANCHOR.TOPRIGHT then
									self:AnchorSet( loc_id, ARKINV_G.ANCHOR.TOPRIGHT )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
					end
					
					
					if value == "BAR_PADDING" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_BARS_PADDING"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						dd:AddLine( "text", "Internal",
							"tooltipTitle", "Internal Padding",
							"tooltipText", "the amount of space to add between the bars and the items",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "bar", "pad", "internal" } ),
							"sliderMin", 4,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "bar", "pad", "internal" } ) then
									self:OptionLocalSet( loc_id, { "bar", "pad", "internal" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", "External",
							"tooltipTitle", "External Padding",
							"tooltipText", "the amount of space to add between bars",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:OptionLocalGet( loc_id, { "bar", "pad", "external" } ),
							"sliderMin", 0,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self:OptionLocalGet( loc_id, { "bar", "pad", "external" } ) then
									self:OptionLocalSet( loc_id, { "bar", "pad", "external" }, v )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
					end
				
					if value == "BAR_ANCHOR" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_BARS_ANCHOR"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_BOTTOMRIGHT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_GENERIC_BOTTOMRIGHT"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_ANCHOR_BOTTOMRIGHT_TEXT"],
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "anchor" } ) == ARKINV_G.ANCHOR.BOTTOMRIGHT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= ARKINV_G.ANCHOR.BOTTOMRIGHT then
									self:OptionLocalSet( loc_id, { "bar", "anchor" }, ARKINV_G.ANCHOR.BOTTOMRIGHT )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_BOTTOMLEFT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_GENERIC_BOTTOMLEFT"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_ANCHOR_BOTTOMLEFT_TEXT"],
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "anchor" } ) == ARKINV_G.ANCHOR.BOTTOMLEFT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= ARKINV_G.ANCHOR.BOTTOMLEFT then
									self:OptionLocalSet( loc_id, { "bar", "anchor" }, ARKINV_G.ANCHOR.BOTTOMLEFT )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_TOPLEFT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_GENERIC_TOPLEFT"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_ANCHOR_TOPLEFT_TEXT"],
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "anchor" } ) == ARKINV_G.ANCHOR.TOPLEFT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= ARKINV_G.ANCHOR.TOPLEFT then
									self:OptionLocalSet( loc_id, { "bar", "anchor" }, ARKINV_G.ANCHOR.TOPLEFT )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_TOPRIGHT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_GENERIC_TOPRIGHT"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_ANCHOR_TOPRIGHT_TEXT"],
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "anchor" } ) == ARKINV_G.ANCHOR.TOPRIGHT,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "anchor" } ) ~= ARKINV_G.ANCHOR.TOPRIGHT then
									self:OptionLocalSet( loc_id, { "bar", "anchor" }, ARKINV_G.ANCHOR.TOPRIGHT )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
					end
				
					if value == "BAR_DIRECTION" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_BARS_DIRECTION"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_HORIZONTAL"],
							"tooltipTitle", ARKINV_L["MOD_MENU_GENERIC_HORIZONTAL"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_DIRECTION_HORIZONTAL_TEXT"],
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "direction" } ) == ARKINV_G.DIRECTION.HORIZONTAL,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "direction" } ) ~= ARKINV_G.DIRECTION.HORIZONTAL then
									self:OptionLocalSet( loc_id, { "bar", "direction" }, ARKINV_G.DIRECTION.HORIZONTAL )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_VERTICAL"],
							"tooltipTitle", ARKINV_L["MOD_MENU_GENERIC_VERTICAL"],
							"tooltipText", ARKINV_L["MOD_MENU_MAIN_BARS_DIRECTION_VERTICAL_TEXT"],
							"disabled", true,
							"isRadio", true,
							"checked", self:OptionLocalGet( loc_id, { "bar", "direction" } ) == ARKINV_G.DIRECTION.VERTICAL,
							"func", function()
								if self:OptionLocalGet( loc_id, { "bar", "direction" } ) ~= ARKINV_G.DIRECTION.VERTICAL then
									self:OptionLocalSet( loc_id, { "bar", "direction" }, ARKINV_G.DIRECTION.VERTICAL )
									self:ContainerGenerateRedrawAll()
								end
							end
						)
					end

					
					if value == "EMPTY_COLOUR" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_EMPTY_COLOUR"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						for k, v in self:spairs( self:OptionLocalGet( loc_id, { "slot", "data" } ), function(a,b) return self:OptionLocalGet( loc_id, { "slot", "data", a, "long" } ) < self:OptionLocalGet( loc_id, { "slot", "data", b, "long" } ) end ) do
							dd:AddLine( "text", v.long,
								"hasColorSwatch", true,
								"r", self:OptionLocalGet( loc_id, { "slot", "data", k, "colour", "r" } ),
								"g", self:OptionLocalGet( loc_id, { "slot", "data", k, "colour", "g" } ),
								"b", self:OptionLocalGet( loc_id, { "slot", "data", k, "colour", "b" } ),
								"colorFunc", function( r, g, b )
									self:OptionLocalSet( loc_id, { "slot", "data", k, "colour", "r" }, r )
									self:OptionLocalSet( loc_id, { "slot", "data", k, "colour", "g" }, g )
									self:OptionLocalSet( loc_id, { "slot", "data", k, "colour", "b" }, b )
									self:ContainerGenerateRefreshAll()
								end
							)
						end

					end

					
					if value == "AUTO_OPEN" then

						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_AUTO_OPEN"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["LOCATION_BANK"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_BANK_OPEN_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.open.bank,
							"func", function()
								self.db.account.option.auto.open.bank = not self.db.account.option.auto.open.bank
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_MAILBOX"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_MAILBOX_OPEN_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.open.mail,
							"func", function()
								self.db.account.option.auto.open.mail = not self.db.account.option.auto.open.mail
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_MERCHANT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_MAILBOX_OPEN_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.open.merchant,
							"func", function()
								self.db.account.option.auto.open.merchant = not self.db.account.option.auto.open.merchant
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_TRADE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_TRADE_OPEN_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.open.trade,
							"func", function()
								self.db.account.option.auto.open.trade = not self.db.account.option.auto.open.trade
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_AUCTION"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_OPEN"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_AUCTION_OPEN_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.open.auction,
							"func", function()
								self.db.account.option.auto.open.auction = not self.db.account.option.auto.open.auction
							end
						)
					
					end
					
					if value == "AUTO_CLOSE" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_AUTO_CLOSE"] ), "isTitle", true, "textHeight", 12 )
						dd:AddLine()
						
						dd:AddLine( "text", ARKINV_L["LOCATION_BANK"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_BANK_CLOSE_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.close.bank,
							"func", function()
								self.db.account.option.auto.close.bank = not self.db.account.option.auto.close.bank
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_MAILBOX"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_MAILBOX_CLOSE_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.close.mail,
							"func", function()
								self.db.account.option.auto.close.mail = not self.db.account.option.auto.close.mail
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_MERCHANT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_MERCHANT_CLOSE_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.close.merchant,
							"func", function()
								self.db.account.option.auto.close.merchant = not self.db.account.option.auto.close.merchant
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_TRADE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_TRADE_CLOSE_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.close.trade,
							"func", function()
								self.db.account.option.auto.close.trade = not self.db.account.option.auto.close.trade
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_AUCTION"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_AUCTION_CLOSE_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.close.auction,
							"func", function()
								self.db.account.option.auto.close.auction = not self.db.account.option.auto.close.auction
							end
						)
						dd:AddLine( "text", ARKINV_L["MOD_MENU_MAIN_AUTO_COMBAT"],
							"tooltipTitle", ARKINV_L["MOD_MENU_MAIN_AUTO_CLOSE"],
							"tooltipText", format( ARKINV_L["MOD_MENU_MAIN_AUTO_COMBAT_CLOSE_TEXT"], ARKINV_G.PROGRAM_NAME ),
							"checked", self.db.account.option.auto.close.combat,
							"func", function()
								self.db.account.option.auto.close.combat = not self.db.account.option.auto.close.combat
							end
						)
						
					end

				end
				
				
				
				-- try to add the base options (will fail where it's not supposed to exist so this is safe to use this way albeit crude)
				dd:FeedAceOptionsTable( base_options )
				
				if level == 1 then
				
					dd:AddLine()
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_CLOSE_MENU"],
						"func", function()
							dd:Close()
						end
					)

				end

			end
			
		)

	end
	
	
	
end

function ARKINV:MenuBarOpen()

	if dd:IsOpen( this ) then

		dd:Close()
		
	else

		local loc_id, _, _, current_player = self:ItemButton_Details()
		local barnum = this:GetParent():GetID()
		
		local x, pos
		x = this:GetRight()
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			pos = "TOPRIGHT"
		else
			pos = "TOPLEFT"
		end
	
		local cat_type = {
			[1] = "SYSTEM",
			[2] = "SKILL",
			[3] = "CLASS",
			[4] = "EMPTY",
			[5] = "RULE",
		}
		
		dd:Open( this,
			"point", pos,
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
				
					dd:AddLine( "text", string.upper( format( ARKINV_L["MOD_MENU_BAR_INFORMATION_TITLE"], barnum ) ), "isTitle", true, "textHeight", 12 )
					
					dd:AddLine()
					dd:AddLine( "text", ARKINV_L["MOD_MENU_BAR_CATEGORY_CURRENT"] .. ":", "isTitle", true )
			
					for _, cat in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do
					
						cat_bar, def_bar = self:CategoryLocationGet( loc_id, cat.id )
					
						if not def_bar and abs( cat_bar ) == barnum then
						
							local t = cat.type
							local n = format( "%s: %s", ARKINV_L["CATEGORY_" .. cat.type], cat.name )
--							if t == "RULE" then
--								n = format( "%s %d: %s", ARKINV_L["CATEGORY_" .. cat.type], cat.id, cat.name )
--							end
							local c = GREEN_FONT_COLOR_CODE
							if cat_bar < 0 then
								c = RED_FONT_COLOR_CODE
							end
							
							-- assigned categories for this bar - displayed in green, hidden displayed in red
							dd:AddLine( "text", c .. n .. FONT_COLOR_CODE_CLOSE,
								"hasArrow", cat.id ~= 0,
								"value", "CATEGORY_CURRENT_" .. cat.type .. "_" .. cat.id
							)

						end
						
					end

					dd:AddLine()
					dd:AddLine( "text", ARKINV_L["MOD_MENU_BAR_CATEGORY_ASSIGN"] .. ":", "isTitle", true )
					
					for _, v in ipairs( cat_type ) do
						dd:AddLine( "text", ARKINV_L["CATEGORY_" .. v],
							"hasArrow", true,
							"value", "CATEGORY_ASSIGN_" .. v
						)
					end
					
					dd:AddLine()
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_BAR_CLEAR"],
						"tooltipTitle", ARKINV_L["MOD_MENU_BAR_CLEAR"],
						"tooltipText", ARKINV_L["MOD_MENU_BAR_CLEAR_TEXT"],
						"func", function()
							dd:Close()
							self:CategoryBarClear( loc_id, barnum )
							self:ContainerGenerateRebuildAll()
						end
					)
					dd:AddLine( "text", ARKINV_L["MOD_MENU_BAR_INSERT"],
						"tooltipTitle", ARKINV_L["MOD_MENU_BAR_INSERT"],
						"tooltipText", ARKINV_L["MOD_MENU_BAR_INSERT_TEXT"],
						"func", function()
							dd:Close()
							self:CategoryBarInsert( loc_id, barnum )
							self:ContainerGenerateRebuildAll()
						end
					)
					dd:AddLine( "text", ARKINV_L["MOD_MENU_BAR_REMOVE"],
						"tooltipTitle", ARKINV_L["MOD_MENU_BAR_REMOVE"],
						"tooltipText", ARKINV_L["MOD_MENU_BAR_REMOVE_TEXT"],
						"func", function()
							dd:Close()
							self:CategoryBarRemove( loc_id, barnum )
							self:ContainerGenerateRebuildAll()
						end
					)
					
					dd:AddLine()
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_CLOSE_MENU"],
						"func", function()
							dd:Close()
						end
					)
					
				end
				
				
				if level == 2 and value then

					local t, k = strmatch( value, "CATEGORY_CURRENT_(.-)_(.+)" )
				
					if k then
					
						category_id = tonumber( k )
						
						dd:AddLine( "text", self:CategoryNameGet( category_id ), "isTitle", true, "textHeight", 12 )
						
						dd:AddLine()
					
						dd:AddLine(	"text", format( ARKINV_L["MOD_MENU_ITEM_MOVE"], LIGHTYELLOW_FONT_COLOR_CODE .. self:CategoryNameGet( category_id ) .. FONT_COLOR_CODE_CLOSE ),
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self:CategoryLocationGet( loc_id, category_id ),
							"sliderMin", 1,
							"sliderMax", self.db.account.cache.who[current_player].loc[loc_id].bar_count + 1,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if self:CategoryLocationGet( loc_id, category_id ) ~= v then
									self:CategoryLocationSet( loc_id, category_id, v )
									self:ContainerGenerateRebuildAll()
								end
							end
						)

						dd:AddLine()

						dd:AddLine( "text", ARKINV_L["MOD_MENU_BAR_CATEGORY_REMOVE"],
							"tooltipTitle", ARKINV_L["MOD_MENU_BAR_CATEGORY_REMOVE"],
							"tooltipText", format( ARKINV_L["MOD_MENU_BAR_CATEGORY_REMOVE_TEXT"], self:CategoryNameGet( category_id ), barnum ),
							"func", function()
								self:CategoryLocationSet( loc_id, category_id, nil )
								self:ContainerGenerateRebuildAll()
							end
						)

						dd:AddLine( "text", ARKINV_L["MOD_MENU_BAR_CATEGORY_HIDDEN"],
							"tooltipTitle", ARKINV_L["MOD_MENU_BAR_CATEGORY_HIDDEN"],
							"tooltipText", ARKINV_L["MOD_MENU_BAR_CATEGORY_HIDDEN_TEXT"],
							"checked", self:CategoryHiddenCheck( loc_id, category_id ),
							"func", function()
								self:CategoryHiddenToggle( loc_id, category_id )
								self:ContainerGenerateRebuildAll()
							end
						)
						
					end

				
					k = strmatch( value, "CATEGORY_ASSIGN_(.*)" )
					
					if k then
					
						dd:AddLine( "text", k, "isTitle", true, "textHeight", 12 )

						dd:AddLine()

						for _, cat in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do

							local t = cat.type
							local cat_bar, def_bar = self:CategoryLocationGet( loc_id, cat.id )
							
							if abs( cat_bar ) == barnum and not def_bar then
								t = "IGNORE" -- change the category so it doesn't display
							end

							if t == "RULE" then
								if not self.db.profile.option.rule[cat.id].enabled then
									t = "IGNORE" -- don't display disabled rules
								end
							end
							
							--self:Debug( "id=" .. cat.id .. ", type=[" .. cat.type .. "], value=[" .. value .. "]" )
							local n = cat.name
							
							-- self:Print( "k[" .. k .. "] == t[" .. t .. "]" )
							if k == t then

								if not def_bar then
									-- category is assigned to a bar - show the user where
									n = LIGHTYELLOW_FONT_COLOR_CODE .. n .. GREEN_FONT_COLOR_CODE .. "  [" .. self:CategoryLocationGet( loc_id, cat.id ) .. "]" .. FONT_COLOR_CODE_CLOSE
								end

								dd:AddLine( "text", n,
									"tooltipTitle", ARKINV_L["MOD_MENU_BAR_CATEGORY"],
									"tooltipText", format( ARKINV_L["MOD_MENU_BAR_CATEGORY_TEXT"], cat.name ),
									"func", function()
										self:CategoryLocationSet( loc_id, cat.id, barnum )
										self:ContainerGenerateRebuildAll()
									end
								)
							end

						end
					
					end

				end

			end
		)

	end
	
end

function ARKINV:MenuItemOpen()

	if ARKINV_G.MODE.EDIT == false then
		return
	end

	local loc_id, bagnum, slotnum, current_player, i = self:ItemButton_Details()

	
	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else
	
		local x, pos
		x = this:GetRight()
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			pos = "TOPRIGHT"
		else
			pos = "TOPLEFT"
		end
	
		local ic = select( 4, GetItemQualityColor( i.q ) )
		local barnum = abs( self:CategoryLocationGet( loc_id, i.cat ) )
		
		local cat_type = {
			[1] = "RULE",
		}
		

		dd:Open( this,
			"point", pos,
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
			
					dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_ITEM_INFORMATION_TITLE"] ) .. ":", "isTitle", true, "textHeight", 12 )
					
					dd:AddLine()
					
					dd:AddLine( "text",  ARKINV_L["MOD_MENU_ITEM_ITEM"] .. ": " .. ic .. ( self:GetItemName( i.h ) or "" ) )
					
					dd:AddLine()
					if i.catdef then
						dd:AddLine( "text", ARKINV_L["MOD_MENU_ITEM_DEFAULT_ASSIGNMENT"] .. ": " .. GREEN_FONT_COLOR_CODE .. self:CategoryNameGet( i.cat ) .. FONT_COLOR_CODE_CLOSE,
							"notClickable", true
						)
						dd:AddLine()
					end
	
					dd:AddLine( "text", ARKINV_L["MOD_MENU_ITEM_DEFAULT_ASSIGNMENT"] .. ": " .. GREEN_FONT_COLOR_CODE .. self:CategoryNameGet( i.catdef or i.cat ) .. FONT_COLOR_CODE_CLOSE,
						"notClickable", true
					)
					
					dd:AddLine()
					dd:AddLine(	"text", format( ARKINV_L["MOD_MENU_ITEM_MOVE"], LIGHTYELLOW_FONT_COLOR_CODE .. self:CategoryNameGet( i.cat ) .. FONT_COLOR_CODE_CLOSE ),
						"hasArrow", true,
						"hasSlider", true,
						"sliderValue", self:CategoryLocationGet( loc_id, i.cat ),
						"sliderMin", 1,
						"sliderMax", self.db.account.cache.who[current_player].loc[loc_id].bar_count + 1,
						"sliderStep", 1,
						"sliderFunc", function( v )
							if self:CategoryLocationGet( loc_id, i.cat ) ~= v then
								self:CategoryLocationSet( loc_id, i.cat, v )
								self:ContainerGenerateRebuildAll()
							end
						end
					)

					dd:AddLine()
					dd:AddLine( "text", ARKINV_L["MOD_MENU_ITEM_RULE_ADD"],
						"hasArrow", true,
						"value", "ITEM_RULE_ADD"
					)

					dd:AddLine()
					dd:AddLine( "text", ARKINV_L["MOD_MENU_ITEM_DEBUG"],
						"hasArrow", true,
						"value", "DEBUG_INFO"
					)
					
					dd:AddLine()
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_CLOSE_MENU"],
						"func", function()
							dd:Close()
						end
					)
					
				end

				if level == 2 and value then

					if value == "ITEM_RULE_ADD" then
					
						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_ITEM_RULE_ADD"] ), "isTitle", true, "textHeight", 12 )
						
						dd:AddLine()
						
						for k, v in self:spairs( self.db.account.option.rule, function(a,b) return self.db.account.option.rule[a].name > self.db.account.option.rule[b].name end ) do
							if self.db.profile.option.rule[k].enabled and v.compiled and not v.damaged then
								dd:AddLine( "text", v.name .. LIGHTYELLOW_FONT_COLOR_CODE .. " [" .. k .. "]" .. FONT_COLOR_CODE_CLOSE,
									"value", "ITEM_RULE_ADD_" .. k,
									"func", function()
										self:AddItemToRule( i.h, k )
										dd:Close()
									end
								)
							end
						
						end
						
					end
				
					if value == "DEBUG_INFO" then

						dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_ITEM_DEBUG"] ), "isTitle", true, "textHeight", 12 )
						
						dd:AddLine()
					
						dd:AddLine( "text", "Bag: " .. GREEN_FONT_COLOR_CODE .. bagnum )
						dd:AddLine( "text", "Slot: " .. GREEN_FONT_COLOR_CODE .. slotnum )
						bagtype = ARKINV_SLOT_TABLE[self:BagType( bagnum )].type
						if bagtype then
							dd:AddLine( "text", "Type: " .. GREEN_FONT_COLOR_CODE .. bagtype )
						end
						dd:AddLine()
						dd:AddLine( "text", "AI ID: " .. GREEN_FONT_COLOR_CODE .. i.id )
						dd:AddLine( "text", "AI Category: " .. GREEN_FONT_COLOR_CODE .. i.cat )
			
						if i.h then
							
							local inam, _, irar, ilvl, imin, ityp, isub, icount, iloc, itxt = GetItemInfo( i.h )
							iloc = getglobal( iloc )
							if not iloc then
								iloc = ""
							end
							
							dd:AddLine()
							dd:AddLine( "text", "Name: " .. GREEN_FONT_COLOR_CODE .. inam )
							local ilnk = strmatch( i.h, "(%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+)" )
							dd:AddLine( "text", "ID: " .. GREEN_FONT_COLOR_CODE .. ilnk )
							dd:AddLine( "text", "Rarity: " .. GREEN_FONT_COLOR_CODE .. irar )
							dd:AddLine( "text", "Item Level: " .. GREEN_FONT_COLOR_CODE .. ilvl )
							dd:AddLine( "text", "Min Level: " .. GREEN_FONT_COLOR_CODE .. imin )
							dd:AddLine( "text", "Type: " .. GREEN_FONT_COLOR_CODE .. ityp )
							dd:AddLine( "text", "Sub Type: " .. GREEN_FONT_COLOR_CODE .. isub )
							dd:AddLine( "text", "Stack Size: " .. GREEN_FONT_COLOR_CODE .. icount )
							dd:AddLine( "text", "Location: " .. GREEN_FONT_COLOR_CODE .. iloc )
							dd:AddLine( "text", "Texture: " .. GREEN_FONT_COLOR_CODE .. itxt )
							
							dd:AddLine()
							
							dd:AddLine( "text", ARKINV_L["MOD_MENU_ITEM_DEBUG_PT"],
								"hasArrow", true,
								"tooltipTitle", ARKINV_L["MOD_MENU_ITEM_DEBUG_PT"],
								"tooltipText", ARKINV_L["MOD_MENU_ITEM_DEBUG_PT_TEXT"],
								"value", "DEBUG_INFO_PT"
							)
							
						end

					end
					
				end

				if level == 3 and value then
				
					if value == "DEBUG_INFO_PT" then

						dd:AddLine( "text", ARKINV_L["MOD_MENU_ITEM_DEBUG_PT_TITLE"] .. ":", "isTitle", true, "textHeight", 12 )
					
						dd:AddLine()
					
						local pt_set = ARKINV_G.PT:ItemSearch( i.h )
						
						if not pt_set then
						
							dd:AddLine( "text", LIGHTYELLOW_FONT_COLOR_CODE .. ARKINV_L["MOD_MENU_ITEM_DEBUG_PT_NONE"] )
						
						else
						
							for k, v in pairs( pt_set ) do
								dd:AddLine( "text", v,
									"hasArrow", true,
									"hasEditBox", true,
									"editBoxText", v
								)
							end
							
						end

					end
				
				end
				
			end
		)
		
	end
	
end

function ARKINV:MenuRuleOpen()

	if dd:IsOpen( this ) then

		dd:Close()
		
	else

		local x, pos
		x = this:GetRight()
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			pos = "TOPRIGHT"
		else
			pos = "TOPLEFT"
		end
	
		dd:Open( this,
			"point", pos,
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
				
					dd:AddLine( "text", string.upper( ARKINV_L["MOD_MENU_MAIN_RULES"] ), "isTitle", true, "textHeight", 12 )
					
					dd:AddLine()

					dd:AddLine( "text", ARKINV_L["MOD_MENU_RULE_SHOWDISABLED"],
						"tooltipTitle", ARKINV_L["MOD_MENU_RULE_SHOWDISABLED"],
						"tooltipText", ARKINV_L["MOD_MENU_RULE_SHOWDISABLED_TEXT"],
						"checked", self.db.account.option.showdisabled,
						"func", function()
							dd:Close()
							self.db.account.option.showdisabled = not self.db.account.option.showdisabled,
							self:RuleUiTableReset( "ARKINV_RulesFrameView" )
							self:RuleUiTableRefresh( "ARKINV_RulesFrame" )
						end
					)
					
					dd:AddLine()
					
					dd:AddLine( "text", ARKINV_L["MOD_MENU_GENERIC_CLOSE_MENU"],
						"func", function()
							dd:Close()
						end
					)
					
				end
				
				
				if level == 2 and value then
				end

			end
		)

	end
	
end


function ARKINV:CacheCleanup()

	--self:Debug( "CacheCleanup() start" )

	for player, player_data in pairs( self.db.account.cache.who ) do

		for loc_id, loc_data in pairs( player_data.loc ) do
			
			--self:Debug( "checking cache: who=" .. player .. ", location=" .. loc_id )
			
			if loc_id == ARKINV_G.LOCATION_BANK and not self.db.account.option.offline.bank then
				-- erase bank if not needed
				--self:Debug( "erasing cached bank data for " .. player )
				self.db.account.cache.who[player].loc[loc_id] = nil
			end
	
		end

		if player ~= ARKINV_G.ME and not self.db.account.option.offline.alt then
			--self:Debug( "erasing cached data for " .. player )
			self.db.account.cache.who[player] = nil
		end

	end

	--self:Debug( "CacheCleanup() end" )
	
end


function ARKINV:SkillGet()

	local good = false
	
	-- self:Print( "GetNumSkillLines() = " .. GetNumSkillLines() )
	
	for j = 1, GetNumSkillLines() do
	
		local name, header = GetSkillLineInfo( j )

		if header ~= nil then

			if name == ARKINV_L["WOW_SKILL_HEADER_PRIMARY"] or name == ARKINV_L["WOW_SKILL_HEADER_SECONDARY"] then
				-- self:Print( "header = " .. name )
				good = true
			else
				good = false
			end
			
		else
		
			if good then
				-- self:Print( "name = " .. name )
				local skill = strmatch( ARKINV_L:GetReverseTranslation( name ), "WOW_SKILL_(.+)" )
				ARKINV_G.PLAYER_SKILLS[skill] = j
			end
			
		end
		
	end
	
end

function ARKINV:SkillPrint()
	for k, v in pairs( ARKINV_G.PLAYER_SKILLS ) do
		self:Print( "skill: " .. k .. " = " .. v )
	end
end

function ARKINV:HookBlizzardAPI()

	if self.db.account.option.framehide.blizzard then
	
		self:Hook( "OpenBackpack", "HookBackpackOpen", true )
		self:Hook( "ToggleBackpack", "HookBackpackToggle", true )

		self:Hook( "OpenAllBags", "HookBackpackOpen", true )

		self:Hook( "ToggleKeyRing", "HookKeyringToggle", true )

		--self:Hook( "OpenBag", "HookBagOpen", true )
		--self:Hook( "ToggleBag", "HookBagToggle", true )

		self:Hook( "OpenBag", "HookDoNothing", true )
		self:Hook( "ToggleBag", "HookDoNothing", true )
	
		BankFrame:UnregisterEvent( "BANKFRAME_OPENED" )
		BankFrame:UnregisterEvent( "BANKFRAME_CLOSED" )
		
		--self:HookReport()
		
	else

		BankFrame:RegisterEvent( "BANKFRAME_OPENED" )
		BankFrame:RegisterEvent( "BANKFRAME_CLOSED" )
	
		self:UnhookAll()

		--self:HookReport()
	
	end
	
end

function ARKINV:HookBackpackOpen()
	--self:Debug( { RED_FONT_COLOR_CODE, "HookBackpackOpen()" } )
	self:ContainerOpen( ARKINV_G.LOCATION_BAG )
end

function ARKINV:HookBackpackToggle()
	--self:Debug( { RED_FONT_COLOR_CODE, "HookBackpackToggle()" } )
	self:ContainerToggle( ARKINV_G.LOCATION_BAG )
end

function ARKINV:HookBagOpen( bagnum )
	--self:Debug( { RED_FONT_COLOR_CODE, "HookBagOpen( ", bagnum, " )" } )
	if bagnum then
		self:ContainerOpen( self:BagLocation( bagnum ), ARKINV_G.ME )
	end
end

function ARKINV:HookKeyringToggle()
	--self:Debug( { RED_FONT_COLOR_CODE, "HookKeyringToggle()" } )
	self:ContainerToggle( ARKINV_G.LOCATION_KEY )
end

function ARKINV:HookBagToggle( bagnum )
	--self:Debug( { RED_FONT_COLOR_CODE, "HookBagToggle( ", bagnum, " )" } )
	if bagnum then
		local loc_id = self:BagLocation( bagnum )
		self:ContainerToggle( loc_id )
	end
end

function ARKINV:HookDoNothing()
	--self:Debug( { RED_FONT_COLOR_CODE, "HookDoNothing()" } )
	-- do nothing
end


function ARKINV:BagChangerUpdateBagSlotStatus()

	-- update blizzards frame as well because the static dialog box uses the data in it
	UpdateBagSlotStatus()

	-- now mimc that frame in ours
	local purchaseFrame = ARKINV_BankFramePurchaseInfo
	if( purchaseFrame == nil ) then
		return
	end
	
	local numSlots, full = GetNumBankSlots()
	local button
	for i = 1, NUM_BANKBAGSLOTS do
		button = getglobal( "ARKINV___Bag" .. i )
		if button then
			if i <= numSlots then
				SetItemButtonTextureVertexColor( button, 1.0, 1.0, 1.0 )
				button.tooltipText = BANK_BAG
			else
				SetItemButtonTextureVertexColor( button, 1.0, 0.1, 0.1 )
				button.tooltipText = BANK_BAG_PURCHASE
			end
		end
	end

	-- pass in # of current slots, returns cost of next slot
	local cost = GetBankSlotCost( numSlots )
	
	ARKINV_BlizzardBankBagChanger.nextSlotCost = cost
	if( GetMoney() >= cost ) then
		SetMoneyFrameColor( "ARKINV_BankFrameDetailMoneyFrame", 1.0, 1.0, 1.0 )
		ARKINV_BankFramePurchaseButton:Enable()
	else
		SetMoneyFrameColor( "ARKINV_BankFrameDetailMoneyFrame", 1.0, 0.1, 0.1 )
		ARKINV_BankFramePurchaseButton:Disable()
	end
	MoneyFrame_Update( "ARKINV_BankFrameDetailMoneyFrame", cost )

	if full then
		purchaseFrame:Hide()
	else
		purchaseFrame:Show()
	end
	
end


function ARKINV:ContainerItemNameGet( loc_id, bagnum, slotnum )
	return ARKINV_G.GUI_NAME .. loc_id .. "Container" .. "Bag" .. bagnum .. "Slot" .. slotnum
end


function ARKINV:OptionLocalGet( loc_id, opt )

	if not loc_id or not opt then
		return nil
	end

	if self.db.profile.option.useglobal then
		loc_id = ARKINV_G.LOCATION_BAG
	end
	
	if opt[5] then
		return self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]][opt[4]][opt[5]]
	end
	
	if opt[4] then
		return self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]][opt[4]]
	end
	
	if opt[3] then
		return self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]]
	end
	
	if opt[2] then
		return self.db.profile.option["local"][loc_id][opt[1]][opt[2]]
	end
	
	if opt[1] then
		return self.db.profile.option["local"][loc_id][opt[1]]
	end

	return nil
	
end

function ARKINV:OptionLocalSet( loc_id, opt, v )

	if not loc_id or not opt then
		return
	end

	if self.db.profile.option.useglobal then
		loc_id = ARKINV_G.LOCATION_BAG
	end
	
	if opt[5] then
		self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]][opt[4]][opt[5]] = v
		return
	end
	
	if opt[4] then
		self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]][opt[4]] = v
		return
	end
	
	if opt[3] then
		self.db.profile.option["local"][loc_id][opt[1]][opt[2]][opt[3]] = v
		return
	end
	
	if opt[2] then
		self.db.profile.option["local"][loc_id][opt[1]][opt[2]] = v
		return
	end
	
	if opt[1] then
		self.db.profile.option["local"][loc_id][opt[1]] = v
		return
	end

	return nil
	
end


function ARKINV:ToggleBagChanger()
	self.db.account.option.framehide.changer = not self.db.account.option.framehide.changer
	self:ContainerGenerateRefreshAll()
end

function ARKINV:ToggleEditMode()
	ARKINV_G.MODE.EDIT = not ARKINV_G.MODE.EDIT
	self:ContainerGenerateRedrawAll()
end

function ARKINV:AnchorSet( loc_id, anchor )

	local obj = getglobal( ARKINV_G.GUI_NAME .. loc_id )
	obj:ClearAllPoints()
	
	self:OptionLocalSet( loc_id, { "window", "anchor" }, anchor )
	
	if anchor == ARKINV_G.ANCHOR.BOTTOMRIGHT then
		obj:SetPoint( "BOTTOMRIGHT" )
	end

	if anchor == ARKINV_G.ANCHOR.BOTTOMLEFT then
		obj:SetPoint( "BOTTOMLEFT" )
	end

	if anchor == ARKINV_G.ANCHOR.TOPLEFT then
		obj:SetPoint( "TOPLEFT" )
	end

	if anchor == ARKINV_G.ANCHOR.TOPRIGHT then
		obj:SetPoint( "TOPRIGHT" )
	end

end


function ARKINV:Tooltip( this, txt )
	ARKINV_Tooltip:SetOwner( this, "ANCHOR_LEFT" )
	ARKINV_Tooltip:ClearLines()
	ARKINV_Tooltip:AddLine( txt )
	ARKINV_Tooltip:Show()
end

function ARKINV:AddItemToRule( h, rulenum )

	local d = self.db.account.option.rule[rulenum]
	d.formula = d.formula .. " or id( " .. self:GetItemID( h ) .. " )"
	d["enabled"] = self.db.profile.option.rule[rulenum].enabled
	self:RuleEntryEdit( rulenum, d )

end





function ARKINV:CategoryRenumber( cat_old, cat_new )

	if self.db.profile.option["global"] and self.db.profile.option.global["category"] and self.db.profile.option.global.category["item"] then
		for item_id, cat_id in pairs( self.db.profile.option.global.category.item ) do
			if cat_id == cat_old then
				self.db.profile.option.global.category.item[item_id] = cat_new
			end
		end
	end

	for loc_id in pairs( ARKINV_G.LOCATION ) do
		if self.db.profile.option["local"][loc_id]["category"] then
			for cat_id, barnum in pairs( self.db.profile.option["local"][loc_id]["category"] ) do
				if cat_id == cat_old then
					self.db.profile.option["local"][loc_id]["category"][cat_new] = barnum
					self.db.profile.option["local"][loc_id]["category"][cat_id] = nil
				end
			end
		end
	end

end

function ARKINV:ConvertOldOptions()

	if not self.db.profile.option["version"] then
		self.db.profile.option["version"] = 0
	end

	
	if self.db.profile.option.version < 1.00 then

		self:Print( format( "Upgrading profile %1$s to %2$.2f", self:GetProfile(), 1 ) )
		
		-- don't store data in char db any more
		self:ResetDB( "char" )
	
		-- moved the background colour option
		if self.db.profile.option["window"] and self.db.profile.option.window["background"] then
			self.db.profile.option.window.colour.background = self.db.profile.option.window.background
			self.db.profile.option.window.background = nil
		end
	
		-- moved the close on combat option
		if self.db.profile.option["window"] and self.db.profile.option.window["combat"] then
			self.db.profile.option.window["auto"]["close"]["combat"] = self.db.profile.option.window.combat
			self.db.profile.option.window.combat = nil
		end

		-- moved the slot sort options
		if self.db.profile.option["slot"] and self.db.profile.option.slot["sort"] then
			self.db.profile.option["sort"]["type"] = self.db.profile.option.slot.sort
			self.db.profile.option.slot.sort = nil
		end
	
		-- remove none as an option to sort, use bag/slot instead
		if self.db.profile.option["sort"] and self.db.profile.option.sort["type"] then
			if self.db.profile.option.sort.type == ARKINV_G.SLOT_SORT_NONE then
				self.db.profile.option.sort.type = ARKINV_G.SLOT_SORT_BAGSLOT
			end
		end

	
		if self.db.profile.option["category"] and self.db.profile.option.category["item"] then
			-- new id format
			local new_cat = { }
			local new_key = nil
			for k, v in pairs( self.db.profile.option.category.item ) do
		
				new_key = k
	
				if strmatch( k, "^%-?%d+$" ) then -- original format, just the number
				
					-- adding suffix and soulbound
					new_key = k .. ".0.0.0"
				
				elseif strmatch( k, "^%-?%d+.%-?%d+.%-?%d+$" ) then -- second format id.suffix.soulbound
			
					-- moving soulbound and adding enchant
					local v1, v2, v3 = strmatch( k, "^(%-?%d+).(%-?%d+).(%-?%d+)" )
					new_key = v1 .. "." .. v3 .. "." .. v2 .. ".0"
				
				end
		
				-- id . soulbound . suffix . enchant
				new_cat[new_key] = v
			end
			self.db.profile.option["category"]["item"] = new_cat
		end


		-- individual window widths
		if self.db.profile.option["window"] and self.db.profile.option.window["col"] and type( self.db.profile.option.window.col ) == "number" then
			self.db.profile.option.window.col = {
				[ARKINV_G.LOCATION_BAG] = self.db.profile.option.window.col,
			}
		end

		-- move the default category to it's new id (so it can be hidden)
		if self.db.profile.option["category"] and self.db.profile.option.category["location"] and self.db.profile.option.category.location[0] then
			self.db.profile.option.category.location[ARKINV_G.CATEGORY_ID_DEFAULT] = self.db.profile.option.category.location[0]
			self.db.profile.option.category.location[0] = nil
		end
		
	end
	
	
	if self.db.profile.option.version < 1.30 then
	
		self:Print( format( "Upgrading profile %1$s to %2$.2f", self:GetProfile(), 1.3 ) )
		-- 1.30 changes
	
		if self.db.profile.option["window"] then
	
			if self.db.profile.option.window["scale"] then
				self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["window"]["scale"] = self.db.profile.option.window.scale
				self.db.profile.option.window.scale = nil
			end
			
			if self.db.profile.option.window["col"] then
	
				if self.db.profile.option.window.col[ARKINV_G.LOCATION_BAG] then
					self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["window"]["width"] = self.db.profile.option.window.col[ARKINV_G.LOCATION_BAG]
					self.db.profile.option.window.col[ARKINV_G.LOCATION_BAG] = nil
				end
	
				if self.db.profile.option.window.col[ARKINV_G.LOCATION_BANK] then
					self.db.profile.option["local"][ARKINV_G.LOCATION_BANK]["window"]["width"] = self.db.profile.option.window.col[ARKINV_G.LOCATION_BANK]
					self.db.profile.option.window.col[ARKINV_G.LOCATION_BANK] = nil
				end
	
				if self.db.profile.option.window.col[ARKINV_G.LOCATION_KEY] then
					self.db.profile.option["local"][ARKINV_G.LOCATION_KEY]["window"]["width"] = self.db.profile.option.window.col[ARKINV_G.LOCATION_KEY]
					self.db.profile.option.window.col[ARKINV_G.LOCATION_KEY] = nil
				end
	
				self.db.profile.option.window.col = nil
			
			end

			if self.db.profile.option.window["border"] then
				self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["window"]["border"] = self.db.profile.option.window.border
				self.db.profile.option.window.border = nil
			end

			if self.db.profile.option.window["colour"] then
				self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["window"]["colour"] = self.db.profile.option.window.colour
				self.db.profile.option.window.colour = nil
			end

			if self.db.profile.option.window["ignorehidden"] then
				self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["slot"]["ignorehidden"] = self.db.profile.option.window.ignorehidden
				self.db.profile.option.window.ignorehidden = nil
			end

			if self.db.profile.option.window["auto"] then
				self.db.profile.option["global"]["auto"] = self.db.profile.option.window.auto
				self.db.profile.option.window.auto = nil
			end
	
			if self.db.profile.option.window["framehide"] then
				self.db.profile.option["global"]["framehide"] = self.db.profile.option.window.framehide
				self.db.profile.option.window.framehide = nil
			end

			self.db.profile.option.window["width"] = nil
			self.db.profile.option.window["hideblizzard"] = nil

		end
		
		self.db.profile.option["window"] = nil
		
		if self.db.profile.option["bar"] then
			self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["bar"] = self.db.profile.option.bar
			self.db.profile.option.bar = nil
		end
	
		if self.db.profile.option["slot"] then
			self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["slot"] = self.db.profile.option.slot
			self.db.profile.option.slot = nil
		end
	
		if self.db.profile.option["sort"] then
			self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["sort"] = self.db.profile.option.sort
			self.db.profile.option.sort = nil
		end
	
		if self.db.profile.option["category"] then
				
			if self.db.profile.option.category["custom"] then
				self.db.profile.option["global"]["category"]["custom"] = self.db.profile.option.category.custom
				self.db.profile.option.category.custom = nil
			end
			
			if self.db.profile.option.category["next"] then
				self.db.profile.option["global"]["category"]["next"] = self.db.profile.option.category.next
				self.db.profile.option.category.next = nil
			end
					
			if self.db.profile.option.category["item"] then
			
				for k, v in pairs( self.db.profile.option.category.item ) do
					if v == 0 then
						self.db.profile.option.category.item[k] = nil
					end
				end
			
				self.db.profile.option["global"]["category"]["item"] = self.db.profile.option.category.item
				self.db.profile.option.category.item = nil
			end
	
			if self.db.profile.option.category["location"] then
				self.db.profile.option["local"][ARKINV_G.LOCATION_BAG]["category"] = self.db.profile.option.category.location
				self.db.profile.option.category.location = nil
			end
			
			self.db.profile.option.category = nil
			
		end
			
		if self.db.profile.option["offline"] then
			self.db.profile.option.offline = nil
		end
	
		self.db.profile.option["sync"] = nil

	end

	
	if self.db.profile.option.version < 1.40 then

		self:Print( format( "Upgrading profile %1$s to %2$.2f", self:GetProfile(), 1.4 ) )
		
		-- categories 36, 37, 38 need to be relocated to 25
		if self.db.profile.option["global"] and self.db.profile.option.global["category"] and self.db.profile.option.global.category["item"] then
			for k, v in pairs( self.db.profile.option.global.category.item ) do
				if v == 36 or v == 37 or v == 38 then
					self.db.profile.option.global.category.item[k] = 25
				end
			end
		end
	
	end


	if self.db.profile.option.version < 2.00 then

		self:Print( format( "Upgrading profile %1$s to %2$.2f", self:GetProfile(), 2 ) )
		
		if self.db.profile.option["global"] then
		
			if self.db.profile.option.global["remember"] then
				self.db.profile.option.global.remember["bank"] = nil
				self.db.profile.option.global.remember["alt"] = nil
				self.db.profile.option.global.remember = nil
			end
		
			if self.db.profile.option.global["auto"] then
				if self.db.profile.option.global.auto["open"] then
					self.db.profile.option.global.auto.open["bank"] = nil
					self.db.profile.option.global.auto.open["mail"] = nil
					self.db.profile.option.global.auto.open["trade"] = nil
					self.db.profile.option.global.auto.open["merchant"] = nil
					self.db.profile.option.global.auto.open["auction"] = nil
					self.db.profile.option.global.auto.open = nil
				end
			
				if self.db.profile.option.global.auto["close"] then
					self.db.profile.option.global.auto.close["bank"] = nil
					self.db.profile.option.global.auto.close["mail"] = nil
					self.db.profile.option.global.auto.close["trade"] = nil
					self.db.profile.option.global.auto.close["merchant"] = nil
					self.db.profile.option.global.auto.close["auction"] = nil
					self.db.profile.option.global.auto.close["combat"] = nil
					self.db.profile.option.global.auto.close = nil
				end
				
				self.db.profile.option.global.auto = nil
			
			end
		
			if self.db.profile.option.global["framehide"] then
				self.db.profile.option.global.framehide["blizzard"] = nil
				self.db.profile.option.global.framehide["status"] = nil
				self.db.profile.option.global.framehide["header"] = nil
				self.db.profile.option.global.framehide["changer"] = nil
				self.db.profile.option.global.framehide = nil
			end
	
			if self.db.profile.option.global["useglobal"] then
				self.db.profile.option.useglobal = self.db.profile.option.global.useglobal
				self.db.profile.option.global.useglobal = nil
			end
			
		
			if self.db.profile.option.global["category"] then
	
				local rule_id
				local item_id
				local cat_id
				local sep = "!"
				local cat_rule = sep
		
				if self.db.profile.option.global.category["next"] then
					self.db.profile.option.global.category.next = nil
				end
			
	
				if self.db.profile.option.global.category["pt"] then
					-- move existing pt categorires to rules
					
					di = 0
					for cat_id, cat_name in self:spairs( self.db.profile.option.global.category.pt, function(a,b) return self.db.profile.option.global.category.pt[a] > self.db.profile.option.global.category.pt[b] end ) do
						self:Print( "converting pt category " .. cat_id )
				
						d = { ["enabled"] = true, ["order"] = 1000 + di, ["name"] = "converted pt " .. cat_name, ["formula"] = "pt( " .. cat_name .. " )" }
						rule_id = self.db.account.option.nextrule
						self:RuleEntryAdd( rule_id, d )
						di = di + 1
			
						self.db.profile.option.global.category.pt[cat_id] = nil
				
						for loc_id in pairs( ARKINV_G.LOCATION ) do
							if self.db.profile.option["local"][loc_id]["category"] then
								barnum = self.db.profile.option["local"][loc_id]["category"][cat_id]
								if barnum then
									self.db.profile.option["local"][loc_id]["rule"][rule_id] = barnum
								end
								self.db.profile.option["local"][loc_id]["category"][cat_id] = nil
							end
						end
				
					end
				
					self.db.profile.option.global.category.pt = nil
				
				end
		
		
				if self.db.profile.option.global.category["custom"] then
			
					-- move existing custom categorires to rules
					for cat_id, cat_name in pairs( self.db.profile.option.global.category.custom ) do
						self:Print( "converting custom category " .. cat_id )
						d = { ["enabled"] = true, ["order"] = 500, ["name"] = "converted custom " .. cat_name, ["formula"] = "false" }
						rule_id = self.db.account.option.nextrule
						cat_rule = cat_rule .. cat_id .. "=" .. rule_id .. sep
						self:RuleEntryAdd( rule_id, d )
		
						self.db.profile.option.global.category.custom[cat_id] = nil
					
						for loc_id in pairs( ARKINV_G.LOCATION ) do
							if self.db.profile.option["local"][loc_id]["category"] then
								barnum = self.db.profile.option["local"][loc_id]["category"][cat_id]
								if barnum then
									self.db.profile.option["local"][loc_id]["rule"][rule_id] = barnum
								end
								self.db.profile.option["local"][loc_id]["category"][cat_id] = nil
							end
						end
			
					end
				
					self.db.profile.option.global.category.custom = nil
				
				end

		
				if self.db.profile.option.global.category["item"] then
			
					-- move items that were in a custom category into a rule
					for k, cat_id in pairs( self.db.profile.option.global.category.item ) do
			
						if cat_id < 0 then
				
							local nk1, nk2, nk3 = strmatch( k, "(%-?%d+)%.%-?%d+%.(%-?%d+)%.(%-?%d+)" )
							item_id = nk1 .. ":" .. nk2 .. ":" .. nk3
				
							rule_id = strmatch( cat_rule, sep .. cat_id .. "=(.-)" .. sep )
							
							if rule_id then
							
								rule_id = tonumber( rule_id )
								
								d = self.db.account.option.rule[rule_id]
								d["enabled"] = self.db.profile.option.rule[rule_id].enabled
								d.formula = d.formula .. " or id( " .. item_id .. " )"
								self:RuleEntryEdit( rule_id, d )

							else
								-- deleted category
--[[							
								self:Print( "converting unlinked category " .. cat_id )
								rule_id = self.db.account.option.nextrule
								
								d = { ["enabled"] = true, ["order"] = 300, ["name"] = "converted unlinked " .. abs( cat_id ), ["formula"] = "false" }
								d.formula = d.formula .. " or id( " .. item_id .. " )"
								self:RuleEntryAdd( rule_id, d )
								
								cat_rule = cat_rule .. cat_id .. "=" .. rule_id .. sep
]]--
							end
				
							self.db.profile.option.global.category.item[k] = nil

							for loc_id in pairs( ARKINV_G.LOCATION ) do
								if rule_id and not self.db.profile.option["local"][loc_id]["rule"][rule_id] and self.db.profile.option["local"][loc_id]["category"] then
									barnum = self.db.profile.option["local"][loc_id]["category"][cat_id]
									if barnum then
										self.db.profile.option["local"][loc_id]["rule"][rule_id] = barnum
									end
									self.db.profile.option["local"][loc_id]["category"][cat_id] = nil
								end
							end
							
						end
						
					end
				
				end
		
		
				-- remove any remaining negative categories assigned to bars - deleted custom categories
				for loc_id in pairs( ARKINV_G.LOCATION ) do
					if self.db.profile.option["local"][loc_id]["category"] then
						for cat_id, barnum in pairs( self.db.profile.option["local"][loc_id]["category"] ) do
							if cat_id < 0 then
								self.db.profile.option["local"][loc_id]["category"][cat_id] = nil
							end
						end
					end
				end

		
				-- convert to new basic category numbers
				self:CategoryRenumber( 1, -402 )
				self:CategoryRenumber( 11, -403 )
				self:CategoryRenumber( 12, -404 )
				self:CategoryRenumber( 13, -405 )
				self:CategoryRenumber( 14, -406 )
				self:CategoryRenumber( 15, -407 )
				self:CategoryRenumber( 16, -408 )
				self:CategoryRenumber( 17, -409 )
				self:CategoryRenumber( 18, -410 )
				self:CategoryRenumber( 19, -411 )
				self:CategoryRenumber( 20, -412 )
				self:CategoryRenumber( 22, -413 )
				self:CategoryRenumber( 23, -414 )
				self:CategoryRenumber( 24, -415 )
				self:CategoryRenumber( 25, -416 )
				self:CategoryRenumber( 26, -417 )
				self:CategoryRenumber( 27, -418 )
				self:CategoryRenumber( 28, -419 )
				self:CategoryRenumber( 29, -420 )
				self:CategoryRenumber( 32, -421 )
				self:CategoryRenumber( 33, -422 )
				self:CategoryRenumber( 34, -423 )
				self:CategoryRenumber( 35, -901 )
				self:CategoryRenumber( 39, -424 )
				self:CategoryRenumber( 40, -902 )
				self:CategoryRenumber( 50, -401 )
				self:CategoryRenumber( 51, -425 )
				self:CategoryRenumber( 51, -426 )
				self:CategoryRenumber( 53, -427 )
				self:CategoryRenumber( 54, -428 )
				
				self:CategoryRenumber( 101, -108 )
				self:CategoryRenumber( 102, -107 )
				self:CategoryRenumber( 103, -111 )
				self:CategoryRenumber( 104, -112 )
				self:CategoryRenumber( 105, -101 )
				self:CategoryRenumber( 106, -102 )
				self:CategoryRenumber( 107, -103 )
				self:CategoryRenumber( 108, -104 )
				self:CategoryRenumber( 109, -110 )
				self:CategoryRenumber( 110, -113 )
				self:CategoryRenumber( 111, -105 )
				self:CategoryRenumber( 112, -106 )
				self:CategoryRenumber( 113, -109 )
		
				self:CategoryRenumber( 201, -201 )
				self:CategoryRenumber( 202, -202 )
				self:CategoryRenumber( 203, -203 )
				self:CategoryRenumber( 204, -204 )
				self:CategoryRenumber( 205, -205 )
				self:CategoryRenumber( 206, -206 )
				self:CategoryRenumber( 207, -207 )
				self:CategoryRenumber( 208, -208 )
				self:CategoryRenumber( 209, -209 )
	
				self:CategoryRenumber( 301, -301 )
				self:CategoryRenumber( 2, -302 )
				self:CategoryRenumber( 3, -303 )
				self:CategoryRenumber( 4, -310 )
				self:CategoryRenumber( 5, -304 )
				self:CategoryRenumber( 6, -305 )
				self:CategoryRenumber( 7, -306 )
				self:CategoryRenumber( 8, -307 )
				self:CategoryRenumber( 9, -308 )
				self:CategoryRenumber( 10, -309 )
				self:CategoryRenumber( 30, -310 )
				self:CategoryRenumber( 31, -311 )
				self:CategoryRenumber( 302, -312 )
			
	
				cat_rule = sep
			
				if self.db.profile.option.global.category["item"] then
				
					-- move items that were in a basic category into a rule
					for k, cat_id in pairs( self.db.profile.option.global.category.item ) do
			
						if cat_id < 0 then
					
							local nk1, nk2, nk3 = strmatch( k, "(%-?%d+)%.%-?%d+%.(%-?%d+)%.(%-?%d+)" )
							item_id = nk1 .. ":" .. nk2 .. ":" .. nk3
					
							rule_id = strmatch( cat_rule, sep .. cat_id .. "=(.-)" .. sep )
					
							if rule_id then
							
								rule_id = tonumber( rule_id )
								
								d = self.db.account.option.rule[rule_id]
								d["enabled"] = self.db.profile.option.rule[rule_id].enabled
								d.formula = d.formula .. " or id( " .. item_id .. " )"
								self:RuleEntryEdit( rule_id, d )
								
							else
							
								self:Print( "converting basic category " .. cat_id )
								rule_id = self.db.account.option.nextrule
								
								d = { ["enabled"] = true, ["order"] = 2000, ["name"] = "converted basic " .. self:CategoryNameGet( cat_id ), ["formula"] = "false" }
								d.formula = d.formula .. " or id( " .. item_id .. " )"
								self:RuleEntryAdd( rule_id, d )
								
								cat_rule = cat_rule .. cat_id .. "=" .. rule_id .. sep
								
							end
					
							self.db.profile.option.global.category.item[k] = nil
					
							for loc_id in pairs( ARKINV_G.LOCATION ) do
								if rule_id and self.db.profile.option["local"][loc_id]["category"] then
									barnum = self.db.profile.option["local"][loc_id]["category"][cat_id]
									if barnum then
										self.db.profile.option["local"][loc_id]["rule"][rule_id] = barnum
									end
								end
							end
						end
					
					end
					
					self.db.profile.option.global.category.item = nil
				
				end
	
	
				-- move any remaining basic categories directly to the rule section and remove any remaining categories
				for loc_id in pairs( ARKINV_G.LOCATION ) do
					if self.db.profile.option["local"][loc_id]["category"] then
						for cat_id, barnum in pairs( self.db.profile.option["local"][loc_id]["category"] ) do
							if cat_id < 0 then
								self.db.profile.option["local"][loc_id]["rule"][cat_id] = self.db.profile.option["local"][loc_id]["category"][cat_id]
							end
							self.db.profile.option["local"][loc_id]["category"][cat_id] = nil
						end
					end
				end
	
				
				self.db.profile.option.global.category = nil
				
			end
			
			self.db.profile.option.global = nil
			
		end
		
	end

	
	
	
	
	if self.db.account.option.version < 2.06 then
		self:CacheErase()
	end
	
	-- set version to current mod version
	self.db.profile.option.version = ARKINV_G.PROGRAM_VERSION
	self.db.account.option.version = ARKINV_G.PROGRAM_VERSION
	
end
